

#define	tok_identifier	258
#define	tok_array_identifier	259
#define	tok_label	260
#define	tok_integer_const	261
#define	tok_real_const	262
#define	tok_dp_const	263
#define	tok_complex_const	264
#define	tok_dcomplex_const	265
#define	tok_logical_const	266
#define	tok_string	267
#define	tok_hollerith	268
#define	tok_edit_descriptor	269
#define	tok_letter	270
#define	tok_relop	271
#define	tok_AND	272
#define	tok_OR	273
#define	tok_EQV	274
#define	tok_NEQV	275
#define	tok_NOT	276
#define	tok_power	277
#define	tok_concat	278
#define	tok_ACCEPT	279
#define	tok_ASSIGN	280
#define	tok_BACKSPACE	281
#define	tok_BLOCK	282
#define	tok_BLOCKDATA	283
#define	tok_BYTE	284
#define	tok_CALL	285
#define	tok_CHARACTER	286
#define	tok_CLOSE	287
#define	tok_COMMON	288
#define	tok_COMPLEX	289
#define	tok_CONTINUE	290
#define	tok_DATA	291
#define	tok_DIMENSION	292
#define	tok_DO	293
#define	tok_DOUBLE	294
#define	tok_DOUBLECOMPLEX	295
#define	tok_DOUBLEPRECISION	296
#define	tok_DOWHILE	297
#define	tok_ELSE	298
#define	tok_ELSEIF	299
#define	tok_END	300
#define	tok_ENDDO	301
#define	tok_ENDFILE	302
#define	tok_ENDIF	303
#define	tok_ENTRY	304
#define	tok_EQUIVALENCE	305
#define	tok_EXTERNAL	306
#define	tok_FILE	307
#define	tok_FORMAT	308
#define	tok_FUNCTION	309
#define	tok_GO	310
#define	tok_GOTO	311
#define	tok_IF	312
#define	tok_IMPLICIT	313
#define	tok_INCLUDE	314
#define	tok_INQUIRE	315
#define	tok_INTEGER	316
#define	tok_INTRINSIC	317
#define	tok_LOGICAL	318
#define	tok_NAMELIST	319
#define	tok_NONE	320
#define	tok_OPEN	321
#define	tok_PARAMETER	322
#define	tok_PAUSE	323
#define	tok_PRECISION	324
#define	tok_PRINT	325
#define	tok_PROGRAM	326
#define	tok_READ	327
#define	tok_REAL	328
#define	tok_RETURN	329
#define	tok_REWIND	330
#define	tok_SAVE	331
#define	tok_STOP	332
#define	tok_SUBROUTINE	333
#define	tok_THEN	334
#define	tok_TO	335
#define	tok_TYPE	336
#define	tok_WHILE	337
#define	tok_WRITE	338
#define	tok_illegal	339
#define	EOS	127
#define	REDUCE	340

#line 9 "fortran.y"


/*
  fortran.c:

    Copyright (C) 1992 by Robert K. Moniot.
    This program is free software.  Permission is granted to
    modify it and/or redistribute it.  There is no warranty
    for this program.


	    This grammar is ANSI standard-conforming, except for:
		-- complex constant and a few other ambiguities needing
		   significant lookahead cannot be split across lines.

	    Extensions supported:
		-- Case insensitive.
		 -- Hollerith constants.
		-- Variable names may be longer than 6 characters.  Also
		   allows underscores and dollar signs in names.
		-- DO ... ENDDO and DO WHILE loop forms allowed.
		-- NAMELIST supported.
		-- TYPE and ACCEPT I/O statements allowed.
		-- Tabs are permitted in input, and (except in character data)
		   expand into blanks up to the next column equal to 1 mod 8.
		-- Type declarations INTEGER*2, REAL*8, etc. are allowed.
		-- IMPLICIT NONE allowed.
	 */

/*  Author: R. Moniot
 *  Date:   August 1988
 *  Last revision: July 1993
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ftnchek.h"
#include "symtab.h"

	/* The following section is for use with bison-derived
	   parser.  Define alloca to be malloc for those cases
	   not covered by the cases covered there.  The ifdefs
	   are those in the skeleton parser with includes removed */
#ifdef AIXC	/* IBM RS/6000 xlc compiler does it this way */
#pragma alloca
#endif
#ifndef alloca
#ifdef __GNUC__
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#else /* Not sparc */
#ifdef MSDOS
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#define alloca malloc
#endif /* alloca now defined.  */

void exit();

#ifndef YYDEBUG	/* If not declared otherwise... */
int yydebug;	/* declare yydebug to satisfy extern in ftnchek.c */
#ifdef DEVELOPMENT
#define YYDEBUG 1		/* For development it is handy */
#else
#define YYDEBUG 0
#endif
#endif

#ifdef DEVELOPMENT
#define DEBUG_PARSER
#endif

int current_datatype,	/* set when parse type_name or type_stmt */
    stmt_sequence_no,   /* set when parsing, reset to 0 at end_stmt */
    control_item_count;	/* count of items in control_info_list */
long current_typesize;	/* for type*len declarations */

extern unsigned prev_stmt_line_num; /* shared with advance */

unsigned true_prev_stmt_line_num;	/* shared with symtab.c */

int current_module_hash = -1,	/* hashtable index of current module name */
    current_module_type,
    executable_stmt=FALSE,
    prev_stmt_class=0,
    complex_const_allowed=FALSE, /* for help in lookahead for these */
    in_assignment_stmt=FALSE,
    inside_format=FALSE,	/* when inside parens of FORMAT  */
    integer_context=FALSE,	/* says integers-only are to follow */
    prev_goto=FALSE,
    goto_flag=FALSE;	/* if unconditional GOTO was encountered */

long exec_stmt_count=0;	/* count of executable stmts in program */

PRIVATE void
print_comlist(), print_exprlist(), END_processing();
PRIVATE Token *
  append_token();
PRIVATE int
  do_bounds_type();
/*
  1. dim_bound_lists: dimensioning info for arrays:
       token.class = no. of dimensions,
       token.subclass = no. of elements
  2. expressions
       token.value.integer = hash index (of identifier)
       token.class = type_byte = storage_class << 4 + datatype
       token.subclass = flags: CONST_EXPR, LVALUE_EXPR, etc.
  3. common variable lists
       token.subclass = flag: COMMA_FLAG used to handle extra/missing commas
*/

#define SEQ_HEADER   1
#define SEQ_IMPLICIT 2
#define SEQ_SPECIF   3
#define SEQ_STMT_FUN 4
#define SEQ_EXEC     5
#define SEQ_END      6


#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		801
#define	YYFLAG		-32768
#define	YYNTBASE	100

#define YYTRANSLATE(x) ((unsigned)(x) <= 340 ? yytranslate[x] : 332)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    96,     2,     2,     2,    88,
    87,    90,    97,    89,    93,    95,    92,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    91,     2,    98,
    94,    99,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    85,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    86
};

static const short yyprhs[] = {     0,
     0,     2,     3,     5,     8,    10,    12,    14,    16,    18,
    21,    23,    25,    27,    29,    31,    34,    36,    38,    40,
    42,    44,    47,    50,    54,    56,    58,    60,    62,    64,
    66,    68,    70,    72,    74,    76,    78,    80,    82,    84,
    86,    88,    90,    92,    94,    96,    98,   100,   102,   104,
   106,   108,   110,   112,   114,   116,   118,   120,   122,   124,
   126,   128,   130,   132,   134,   136,   138,   140,   142,   144,
   146,   148,   150,   151,   156,   160,   167,   169,   173,   180,
   184,   191,   194,   196,   198,   200,   202,   204,   206,   210,
   217,   219,   220,   222,   224,   228,   230,   232,   235,   239,
   242,   244,   248,   250,   254,   259,   261,   265,   267,   271,
   273,   277,   278,   283,   287,   293,   297,   301,   303,   305,
   307,   312,   315,   318,   322,   326,   331,   333,   336,   339,
   343,   346,   348,   350,   353,   355,   358,   360,   362,   366,
   368,   371,   374,   378,   380,   383,   385,   388,   392,   396,
   400,   405,   407,   411,   413,   415,   417,   419,   421,   424,
   426,   429,   431,   433,   435,   439,   441,   445,   447,   449,
   451,   455,   457,   461,   463,   467,   469,   473,   477,   479,
   480,   485,   486,   492,   494,   498,   500,   504,   508,   510,
   514,   520,   522,   526,   527,   532,   536,   538,   542,   546,
   548,   552,   555,   559,   561,   565,   567,   571,   575,   577,
   580,   584,   585,   586,   593,   595,   599,   601,   603,   605,
   609,   611,   615,   617,   619,   621,   623,   625,   629,   631,
   633,   641,   645,   651,   652,   653,   660,   662,   664,   666,
   668,   675,   680,   687,   695,   699,   706,   714,   716,   719,
   722,   727,   738,   741,   745,   746,   752,   755,   756,   757,
   766,   769,   772,   776,   782,   783,   791,   792,   799,   803,
   808,   811,   815,   821,   825,   828,   831,   835,   839,   840,
   842,   844,   846,   847,   851,   852,   857,   858,   864,   870,
   877,   885,   889,   895,   897,   901,   907,   911,   912,   913,
   921,   925,   926,   927,   935,   937,   941,   945,   947,   949,
   953,   957,   961,   963,   965,   969,   971,   973,   981,   982,
   989,   990,   997,   998,  1005,  1009,  1015,  1017,  1021,  1027,
  1029,  1032,  1036,  1042,  1044,  1046,  1048,  1050,  1052,  1053,
  1060,  1062,  1065,  1067,  1069,  1071,  1075,  1077,  1079,  1081,
  1083,  1085,  1087,  1089,  1091,  1093,  1095,  1097,  1099,  1101,
  1104,  1107,  1108,  1109,  1115,  1120,  1121,  1123,  1125,  1129,
  1131,  1132,  1136,  1137,  1143,  1144,  1151,  1154,  1156,  1160,
  1164,  1170,  1173,  1177,  1182,  1184,  1185,  1187,  1189,  1193,
  1195,  1197,  1199,  1203,  1207,  1209,  1213,  1215,  1219,  1221,
  1224,  1226,  1230,  1232,  1235,  1238,  1242,  1246,  1248,  1252,
  1256,  1258,  1262,  1264,  1268,  1270,  1272,  1274,  1276,  1278,
  1282,  1284,  1286,  1288,  1290,  1292,  1294,  1296,  1298,  1300,
  1302,  1304,  1306,  1308,  1313,  1318,  1320,  1324,  1326,  1329,
  1332,  1335,  1338,  1342,  1347,  1352,  1358,  1360,  1362,  1364,
  1366,  1368,  1370,  1372,  1374,  1377,  1380,  1382,  1384,  1386,
  1388,  1389
};

static const short yyrhs[] = {   101,
     0,     0,   102,     0,   101,   102,     0,   103,     0,   109,
     0,    85,     0,   104,     0,   107,     0,     5,   105,     0,
   105,     0,   106,     0,   110,     0,   113,     0,   116,     0,
     1,    85,     0,   119,     0,   122,     0,   128,     0,   134,
     0,   108,     0,     5,   108,     0,    45,    85,     0,    59,
    12,    85,     0,   111,     0,   180,     0,   172,     0,   191,
     0,   112,     0,   121,     0,   271,     0,   136,     0,   141,
     0,   148,     0,   155,     0,   161,     0,   184,     0,   186,
     0,   188,     0,   114,     0,   115,     0,   211,     0,   213,
     0,   216,     0,   233,     0,   293,     0,   206,     0,   210,
     0,   212,     0,   232,     0,   234,     0,   241,     0,   243,
     0,   236,     0,   244,     0,   247,     0,   267,     0,   263,
     0,   265,     0,   257,     0,   259,     0,   261,     0,   287,
     0,   117,     0,   118,     0,   217,     0,   218,     0,   226,
     0,   231,     0,   221,     0,   224,     0,   225,     0,     0,
    71,   120,   327,    85,     0,    49,   327,    85,     0,    49,
   327,    88,   131,    87,    85,     0,   123,     0,   124,   327,
    85,     0,   124,   327,    88,   131,    87,    85,     0,   125,
   327,    85,     0,   125,   327,    88,   131,    87,    85,     0,
   127,   126,     0,   126,     0,    54,     0,   162,     0,   165,
     0,   166,     0,   129,     0,   130,   327,    85,     0,   130,
   327,    88,   131,    87,    85,     0,    78,     0,     0,   132,
     0,   133,     0,   132,    89,   133,     0,   327,     0,    90,
     0,   135,    85,     0,   135,   327,    85,     0,    27,    36,
     0,    28,     0,    37,   137,    85,     0,   138,     0,   137,
    89,   138,     0,   327,    88,   139,    87,     0,   140,     0,
   139,    89,   140,     0,   315,     0,   315,    91,   315,     0,
    90,     0,   315,    91,    90,     0,     0,    50,   142,   143,
    85,     0,    88,   144,    87,     0,   143,    89,    88,   144,
    87,     0,   145,    89,   145,     0,   144,    89,   145,     0,
   327,     0,   146,     0,   147,     0,   327,    88,   318,    87,
     0,   327,   322,     0,   146,   322,     0,    33,   152,    85,
     0,    33,   149,    85,     0,    33,   152,   149,    85,     0,
   150,     0,   149,   150,     0,   151,   152,     0,    92,   327,
    92,     0,    92,    92,     0,    23,     0,   153,     0,   152,
   153,     0,   154,     0,   154,    89,     0,   327,     0,   138,
     0,    64,   156,    85,     0,   157,     0,   156,   157,     0,
   158,   159,     0,    92,   327,    92,     0,   160,     0,   159,
   160,     0,   327,     0,   327,    89,     0,   162,   167,    85,
     0,   165,   169,    85,     0,   166,   169,    85,     0,   166,
    89,   169,    85,     0,   163,     0,   163,    90,   329,     0,
   164,     0,    61,     0,    73,     0,    34,     0,    63,     0,
    39,    69,     0,    41,     0,    39,    34,     0,    40,     0,
    29,     0,    31,     0,   165,    90,   179,     0,   168,     0,
   167,    89,   168,     0,   327,     0,   138,     0,   170,     0,
   169,    89,   170,     0,   327,     0,   327,    90,   179,     0,
   138,     0,   138,    90,   179,     0,    58,     0,   171,   173,
    85,     0,   171,    65,    85,     0,   175,     0,     0,   173,
    89,   174,   175,     0,     0,   127,    88,   176,   177,    87,
     0,   178,     0,   177,    89,   178,     0,    15,     0,    15,
    93,    15,     0,    88,    90,    87,     0,   329,     0,    88,
   314,    87,     0,    67,    88,   181,    87,    85,     0,   182,
     0,   181,    89,   182,     0,     0,   327,   183,    94,   298,
     0,    51,   185,    85,     0,   327,     0,   185,    89,   327,
     0,    62,   187,    85,     0,   327,     0,   187,    89,   327,
     0,    76,    85,     0,    76,   189,    85,     0,   190,     0,
   189,    89,   190,     0,   327,     0,    92,   327,    92,     0,
    36,   192,    85,     0,   193,     0,   192,   193,     0,   192,
    89,   193,     0,     0,     0,   196,    92,   194,   198,   195,
    92,     0,   197,     0,   196,    89,   197,     0,   209,     0,
   204,     0,   199,     0,   198,    89,   199,     0,   201,     0,
   200,    90,   201,     0,   329,     0,   327,     0,   328,     0,
   327,     0,   203,     0,   202,    89,   203,     0,   316,     0,
   204,     0,    88,   202,    89,   327,    94,   205,    87,     0,
   314,    89,   314,     0,   314,    89,   314,    89,   314,     0,
     0,     0,   209,    94,   207,   299,   208,    85,     0,   324,
     0,   316,     0,   321,     0,   283,     0,    25,   330,   331,
    80,   324,    85,     0,   214,   330,   331,    85,     0,   214,
    88,   215,    87,   312,    85,     0,   214,    88,   215,    87,
    89,   312,    85,     0,   214,   327,    85,     0,   214,   327,
    88,   215,    87,    85,     0,   214,   327,    89,    88,   215,
    87,    85,     0,    56,     0,    55,    80,     0,   330,   331,
     0,   215,    89,   330,   331,     0,   219,   330,   331,    89,
   330,   331,    89,   330,   331,    85,     0,   219,   113,     0,
   219,    79,    85,     0,     0,    57,    88,   220,   299,    87,
     0,    43,   218,     0,     0,     0,    44,    88,   222,   299,
    87,   223,    79,    85,     0,    43,    85,     0,    48,    85,
     0,    45,    57,    85,     0,   229,   324,    94,   230,    85,
     0,     0,   229,    82,    88,   227,   299,    87,    85,     0,
     0,    42,    88,   228,   299,    87,    85,     0,    38,   330,
   331,     0,    38,   330,   331,    89,     0,    38,   330,     0,
   313,    89,   313,     0,   313,    89,   313,    89,   313,     0,
    45,    38,    85,     0,    46,    85,     0,    35,    85,     0,
    77,   235,    85,     0,    68,   235,    85,     0,     0,     6,
     0,   327,     0,    12,     0,     0,   239,   237,    85,     0,
     0,   239,   254,   238,    85,     0,     0,    83,   240,    88,
   250,    87,     0,   242,    88,   250,    87,    85,     0,   242,
    88,   250,    87,   254,    85,     0,   242,    88,   250,    87,
    89,   254,    85,     0,   242,   270,    85,     0,   242,   270,
    89,   254,    85,     0,    72,     0,    24,   270,    85,     0,
    24,   270,    89,   254,    85,     0,    70,   270,    85,     0,
     0,     0,    70,   270,    89,   245,   254,   246,    85,     0,
    81,   270,    85,     0,     0,     0,    81,   270,    89,   248,
   254,   249,    85,     0,   251,     0,   250,    89,   251,     0,
   327,    94,   269,     0,   269,     0,   269,     0,   327,    94,
   269,     0,   252,    89,   253,     0,   327,    94,   269,     0,
   327,     0,   255,     0,   254,    89,   255,     0,   299,     0,
   256,     0,    88,   254,    89,   324,    94,   230,    87,     0,
     0,    66,   258,    88,   252,    87,    85,     0,     0,    32,
   260,    88,   250,    87,    85,     0,     0,    60,   262,    88,
   250,    87,    85,     0,   264,   269,    85,     0,   264,    88,
   250,    87,    85,     0,    26,     0,   266,   269,    85,     0,
   266,    88,   250,    87,    85,     0,    47,     0,    45,    52,
     0,   268,   269,    85,     0,   268,    88,   250,    87,    85,
     0,    75,     0,   299,     0,    90,     0,   308,     0,    90,
     0,     0,    53,   272,    88,   273,    87,    85,     0,   274,
     0,   273,   274,     0,   275,     0,   276,     0,   277,     0,
    88,   273,    87,     0,    14,     0,    12,     0,    13,     0,
   279,     0,   280,     0,    89,     0,    92,     0,    23,     0,
    91,     0,    95,     0,   278,     0,    96,     0,     6,     0,
    93,     6,     0,    97,     6,     0,     0,     0,    98,   281,
   312,   282,    99,     0,   325,    88,   284,    87,     0,     0,
   285,     0,   286,     0,   285,    89,   286,     0,   324,     0,
     0,   291,   288,    85,     0,     0,   291,    88,    87,   289,
    85,     0,     0,   291,    88,   292,    87,   290,    85,     0,
    30,   327,     0,   299,     0,    90,   330,   331,     0,   292,
    89,   299,     0,   292,    89,    90,   330,   331,     0,    74,
    85,     0,    74,   312,    85,     0,   295,    88,   296,    87,
     0,   325,     0,     0,   297,     0,   299,     0,   297,    89,
   299,     0,   299,     0,   300,     0,   301,     0,   299,    19,
   301,     0,   299,    20,   301,     0,   302,     0,   301,    18,
   302,     0,   303,     0,   302,    17,   303,     0,   304,     0,
    21,   304,     0,   305,     0,   304,    16,   304,     0,   306,
     0,    93,   306,     0,    97,   306,     0,   305,    97,   306,
     0,   305,    93,   306,     0,   307,     0,   306,    92,   307,
     0,   306,    90,   307,     0,   308,     0,   308,    22,   307,
     0,   309,     0,   308,    23,   309,     0,   324,     0,   317,
     0,   294,     0,   320,     0,   310,     0,    88,   299,    87,
     0,   311,     0,    12,     0,    13,     0,    11,     0,     6,
     0,     7,     0,     8,     0,     9,     0,    10,     0,   305,
     0,   305,     0,   305,     0,   305,     0,   326,    88,   318,
    87,     0,   326,    88,   318,    87,     0,   319,     0,   318,
    89,   319,     0,   299,     0,   295,   322,     0,   317,   322,
     0,   325,   322,     0,   316,   322,     0,    88,    91,    87,
     0,    88,   323,    91,    87,     0,    88,    91,   323,    87,
     0,    88,   323,    91,   323,    87,     0,   305,     0,   325,
     0,   326,     0,     3,     0,     4,     0,     3,     0,     4,
     0,   311,     0,    93,   311,     0,    97,   311,     0,    11,
     0,    12,     0,    13,     0,     6,     0,     0,     6,     0
};


static const short yyr1[] = {     0,
   100,   100,   101,   101,   102,   102,   102,   103,   103,   104,
   104,   105,   105,   105,   105,   105,   106,   106,   106,   106,
   107,   107,   108,   109,   110,   110,   110,   110,   110,   111,
   111,   112,   112,   112,   112,   112,   112,   112,   112,   113,
   113,   114,   114,   114,   114,   114,   115,   115,   115,   115,
   115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
   115,   115,   115,   116,   116,   117,   117,   117,   117,   118,
   118,   118,   120,   119,   121,   121,   122,   123,   123,   123,
   123,   124,   125,   126,   127,   127,   127,   128,   129,   129,
   130,   131,   131,   132,   132,   133,   133,   134,   134,   135,
   135,   136,   137,   137,   138,   139,   139,   140,   140,   140,
   140,   142,   141,   143,   143,   144,   144,   145,   145,   145,
   146,   147,   147,   148,   148,   148,   149,   149,   150,   151,
   151,   151,   152,   152,   153,   153,   154,   154,   155,   156,
   156,   157,   158,   159,   159,   160,   160,   161,   161,   161,
   161,   162,   162,   162,   163,   163,   163,   163,   164,   164,
   164,   164,   164,   165,   166,   167,   167,   168,   168,   169,
   169,   170,   170,   170,   170,   171,   172,   172,   173,   174,
   173,   176,   175,   177,   177,   178,   178,   179,   179,   179,
   180,   181,   181,   183,   182,   184,   185,   185,   186,   187,
   187,   188,   188,   189,   189,   190,   190,   191,   192,   192,
   192,   194,   195,   193,   196,   196,   197,   197,   198,   198,
   199,   199,   200,   200,   201,   201,   202,   202,   203,   203,
   204,   205,   205,   207,   208,   206,   209,   209,   209,   209,
   210,   211,   212,   212,   213,   213,   213,   214,   214,   215,
   215,   216,   217,   218,   220,   219,   221,   222,   223,   221,
   224,   225,   225,   226,   227,   226,   228,   226,   229,   229,
   229,   230,   230,   231,   231,   232,   233,   234,   235,   235,
   235,   235,   237,   236,   238,   236,   240,   239,   241,   241,
   241,   241,   241,   242,   243,   243,   244,   245,   246,   244,
   247,   248,   249,   247,   250,   250,   251,   251,   252,   252,
   252,   253,   253,   254,   254,   255,   255,   256,   258,   257,
   260,   259,   262,   261,   263,   263,   264,   265,   265,   266,
   266,   267,   267,   268,   269,   269,   270,   270,   272,   271,
   273,   273,   274,   274,   274,   275,   275,   276,   276,   276,
   276,   277,   277,   277,   277,   277,   277,   278,   279,   279,
   279,   281,   282,   280,   283,   284,   284,   285,   285,   286,
   288,   287,   289,   287,   290,   287,   291,   292,   292,   292,
   292,   293,   293,   294,   295,   296,   296,   297,   297,   298,
   299,   300,   300,   300,   301,   301,   302,   302,   303,   303,
   304,   304,   305,   305,   305,   305,   305,   306,   306,   306,
   307,   307,   308,   308,   309,   309,   309,   309,   309,   309,
   310,   310,   310,   310,   311,   311,   311,   311,   311,   312,
   313,   314,   315,   316,   317,   318,   318,   319,   320,   320,
   321,   321,   322,   322,   322,   322,   323,   324,   324,   325,
   326,   327,   327,   328,   328,   328,   328,   328,   328,   329,
   330,   331
};

static const short yyr2[] = {     0,
     1,     0,     1,     2,     1,     1,     1,     1,     1,     2,
     1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
     1,     2,     2,     3,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     0,     4,     3,     6,     1,     3,     6,     3,
     6,     2,     1,     1,     1,     1,     1,     1,     3,     6,
     1,     0,     1,     1,     3,     1,     1,     2,     3,     2,
     1,     3,     1,     3,     4,     1,     3,     1,     3,     1,
     3,     0,     4,     3,     5,     3,     3,     1,     1,     1,
     4,     2,     2,     3,     3,     4,     1,     2,     2,     3,
     2,     1,     1,     2,     1,     2,     1,     1,     3,     1,
     2,     2,     3,     1,     2,     1,     2,     3,     3,     3,
     4,     1,     3,     1,     1,     1,     1,     1,     2,     1,
     2,     1,     1,     1,     3,     1,     3,     1,     1,     1,
     3,     1,     3,     1,     3,     1,     3,     3,     1,     0,
     4,     0,     5,     1,     3,     1,     3,     3,     1,     3,
     5,     1,     3,     0,     4,     3,     1,     3,     3,     1,
     3,     2,     3,     1,     3,     1,     3,     3,     1,     2,
     3,     0,     0,     6,     1,     3,     1,     1,     1,     3,
     1,     3,     1,     1,     1,     1,     1,     3,     1,     1,
     7,     3,     5,     0,     0,     6,     1,     1,     1,     1,
     6,     4,     6,     7,     3,     6,     7,     1,     2,     2,
     4,    10,     2,     3,     0,     5,     2,     0,     0,     8,
     2,     2,     3,     5,     0,     7,     0,     6,     3,     4,
     2,     3,     5,     3,     2,     2,     3,     3,     0,     1,
     1,     1,     0,     3,     0,     4,     0,     5,     5,     6,
     7,     3,     5,     1,     3,     5,     3,     0,     0,     7,
     3,     0,     0,     7,     1,     3,     3,     1,     1,     3,
     3,     3,     1,     1,     3,     1,     1,     7,     0,     6,
     0,     6,     0,     6,     3,     5,     1,     3,     5,     1,
     2,     3,     5,     1,     1,     1,     1,     1,     0,     6,
     1,     2,     1,     1,     1,     3,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     0,     0,     5,     4,     0,     1,     1,     3,     1,
     0,     3,     0,     5,     0,     6,     2,     1,     3,     3,
     5,     2,     3,     4,     1,     0,     1,     1,     3,     1,
     1,     1,     3,     3,     1,     3,     1,     3,     1,     2,
     1,     3,     1,     2,     2,     3,     3,     1,     3,     3,
     1,     3,     1,     3,     1,     1,     1,     1,     1,     3,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     4,     4,     1,     3,     1,     2,     2,
     2,     2,     3,     4,     4,     5,     1,     1,     1,     1,
     1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
     0,     1
};

static const short yydefact[] = {     0,
     0,   450,   451,     0,     0,   461,   327,     0,   101,   163,
     0,   164,   321,     0,   157,     0,     0,     0,   461,     0,
   162,   160,     0,     0,     0,     0,     0,   330,     0,     0,
   112,     0,   339,    84,     0,   248,     0,   176,     0,   323,
   155,     0,   158,     0,   319,     0,   279,     0,    73,   294,
   156,     0,   334,     0,   279,    91,     0,   287,     7,     0,
     3,     5,     8,    11,    12,     9,    21,     6,    13,    25,
    29,    14,    40,    41,    15,    64,    65,    17,    30,    18,
    77,     0,     0,    83,     0,    19,    88,     0,    20,     0,
    32,    33,    34,    35,    36,    85,   152,   154,    86,    87,
     0,    27,    26,    37,    38,    39,    28,    47,     0,    48,
    42,    49,    43,   461,    44,    66,    67,   461,    70,    71,
    72,    68,     0,    69,    50,    45,    51,    54,   283,    52,
     0,    53,    55,    56,    60,    61,    62,    58,     0,    59,
     0,    57,     0,    31,   240,    63,   371,    46,   238,   239,
   237,   448,   449,    16,    10,    22,   425,   426,   427,   428,
   429,   424,   422,   423,     0,   338,     0,   417,     0,   337,
   413,   419,   421,   416,   418,   415,   448,   449,     0,   100,
   452,   453,   377,     0,   132,     0,   138,     0,   127,     0,
     0,   133,   135,   137,   276,     0,     0,   209,     0,   215,
   218,   217,     0,   103,     0,   271,   161,   159,   267,   261,
   257,     0,   258,     0,   331,     0,    23,   275,   262,     0,
     0,     0,   197,     0,   249,   255,     0,     0,     0,   200,
     0,     0,   140,     0,     0,     0,   280,   282,     0,   281,
     0,     0,   382,     0,     0,   430,   403,   408,   411,     0,
   202,     0,     0,   204,   206,     0,     0,     0,     4,     0,
     0,    82,     0,    98,     0,   169,     0,   166,   168,     0,
     0,   174,     0,   170,   172,     0,     0,     0,     0,    85,
    86,    87,     0,   179,   234,   461,     0,     0,     0,     0,
   253,   461,     0,     0,     0,   448,   449,     0,     0,     0,
   285,   314,   317,   316,   391,   392,   395,   397,   399,   401,
     0,     0,     0,   336,     0,   335,     0,     0,     0,     0,
     0,     0,     0,   442,   366,   441,     0,     0,   295,     0,
   386,   439,     0,   440,     0,   462,     0,     0,   131,     0,
   125,   128,   129,   124,     0,   134,   136,     0,     0,   227,
   230,   229,     0,   208,     0,   210,     0,   212,   102,     0,
   269,     0,     0,   274,   263,    75,    92,     0,     0,   196,
     0,     0,     0,    24,     0,   199,     0,     0,   139,   141,
   142,   144,   146,     0,     0,   192,   194,   278,   297,   298,
     0,   404,   405,     0,     0,     0,     0,     0,   383,     0,
   203,     0,   277,   301,   302,     0,    78,    92,    80,    92,
    89,    92,    99,   148,     0,   460,   153,     0,   165,   189,
     0,   149,     0,     0,     0,   150,   178,   182,   177,   180,
     0,     0,     0,   245,   461,     0,     0,   254,     0,   265,
     0,   400,     0,   316,   284,     0,     0,     0,     0,     0,
     0,     0,   450,   451,     0,   305,   308,   335,     0,   292,
     0,     0,   325,     0,   328,     0,   332,   373,   461,     0,
   378,   372,     0,   447,     0,     0,   367,   368,   415,   438,
     0,   436,   420,     0,     0,   387,   388,   401,   414,     0,
     0,     0,   130,   126,   110,     0,   106,   433,   108,     0,
   211,   216,     0,   104,   270,     0,     0,    97,     0,    93,
    94,    96,     0,     0,   119,   120,   118,   113,     0,   198,
   359,   348,   349,   347,   354,     0,   352,   355,   353,     0,
   356,   358,     0,   362,     0,   341,   343,   344,   345,   357,
   350,   351,     0,     0,   201,   143,   145,   147,     0,   309,
     0,     0,     0,     0,     0,    74,   407,   406,   410,   409,
   412,   207,   205,     0,     0,     0,     0,     0,   167,     0,
   432,     0,   175,   171,   173,   151,     0,     0,   235,     0,
   461,   250,     0,   461,   242,   461,     0,     0,   431,     0,
     0,   315,   286,   393,   394,   396,   398,   402,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   375,     0,   443,
     0,     0,   365,     0,   434,     0,   296,   384,     0,   435,
     0,     0,   105,     0,     0,   228,     0,   425,   457,   458,
   459,     0,     0,   213,   219,     0,   221,   454,   226,   225,
   223,     0,   259,     0,     0,   114,     0,     0,   123,     0,
   122,     0,     0,   360,   361,     0,     0,   342,   256,     0,
     0,     0,     0,   191,   193,     0,   299,   303,   288,     0,
     0,     0,   188,   190,   186,     0,   184,   181,     0,     0,
     0,     0,     0,     0,     0,     0,   264,     0,   415,   289,
     0,     0,   306,   307,   293,   326,   329,   333,   374,   379,
     0,   461,   380,   445,   444,     0,   369,   370,   437,   389,
   241,   322,   107,   111,   109,     0,   455,   456,     0,     0,
     0,   268,     0,    76,    95,   117,   116,     0,     0,   346,
   363,   340,   324,   320,   311,   313,   310,   195,   390,     0,
     0,    79,    81,    90,     0,   183,     0,   236,     0,   243,
   251,   246,     0,     0,     0,   272,     0,     0,   290,   376,
     0,   446,     0,     0,   220,   214,   222,   226,     0,   121,
   115,     0,     0,   300,   304,   187,   185,   244,   247,   461,
   266,     0,     0,   291,   381,   231,     0,   260,   364,   312,
     0,   273,   318,   232,     0,     0,   252,   233,     0,     0,
     0
};

static const short yydefgoto[] = {   799,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,   242,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
   509,   510,   511,    89,    90,    91,   203,   187,   496,   497,
    92,   221,   369,   513,   514,   515,   516,    93,   188,   189,
   190,   191,   192,   193,    94,   232,   233,   234,   381,   382,
    95,    96,    97,    98,    99,   100,   267,   268,   273,   274,
   101,   102,   283,   578,   284,   577,   676,   677,   419,   103,
   385,   386,   554,   104,   222,   105,   229,   106,   253,   254,
   107,   197,   198,   503,   720,   199,   200,   634,   635,   636,
   637,   349,   350,   201,   763,   108,   431,   679,   109,   110,
   111,   112,   113,   114,   432,   115,   116,   117,   118,   373,
   119,   363,   723,   120,   121,   122,   587,   362,   123,   588,
   124,   125,   126,   127,   239,   128,   300,   447,   129,   258,
   130,   131,   132,   133,   555,   740,   134,   564,   741,   455,
   456,   549,   735,   301,   302,   303,   135,   235,   136,   184,
   137,   228,   138,   139,   140,   141,   142,   143,   457,   167,
   144,   224,   535,   536,   537,   538,   539,   540,   541,   542,
   656,   772,   145,   476,   477,   478,   146,   322,   606,   701,
   147,   470,   148,   168,   169,   485,   486,   738,   316,   305,
   306,   307,   308,   309,   310,   247,   248,   249,   171,   172,
   173,   250,   590,   572,   499,   149,   174,   481,   482,   175,
   150,   324,   475,   176,   177,   178,   459,   640,   420,   433,
   337
};

static const short yypact[] = {  1177,
     3,-32768,-32768,  1346,   436,-32768,-32768,    65,-32768,-32768,
   345,-32768,-32768,    81,-32768,     8,    92,   345,-32768,    30,
-32768,-32768,    39,    21,    63,   317,    33,-32768,    93,   345,
-32768,   345,-32768,-32768,   103,-32768,   107,-32768,   202,-32768,
-32768,   345,-32768,   155,-32768,   168,   288,   436,-32768,-32768,
-32768,   752,-32768,   119,   288,-32768,   436,-32768,-32768,  1263,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   345,   345,-32768,   209,-32768,-32768,   345,-32768,   117,
-32768,-32768,-32768,-32768,-32768,   345,   205,-32768,   111,    51,
   586,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   243,-32768,
-32768,-32768,-32768,   187,-32768,-32768,-32768,  1422,-32768,-32768,
-32768,-32768,   227,-32768,-32768,-32768,-32768,-32768,   769,-32768,
  1110,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   122,-32768,
   449,-32768,   600,-32768,-32768,-32768,   183,-32768,   239,-32768,
-32768,   242,   303,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   785,-32768,   179,-32768,   316,   390,
-32768,-32768,-32768,   239,-32768,-32768,   333,   350,   404,-32768,
-32768,-32768,-32768,   363,-32768,    49,-32768,   173,-32768,   345,
    79,-32768,   329,   366,-32768,    57,   150,-32768,    50,-32768,
-32768,-32768,   181,-32768,   366,   404,-32768,-32768,-32768,-32768,
-32768,   351,-32768,   379,-32768,   402,-32768,-32768,-32768,    77,
   405,   244,-32768,   434,-32768,-32768,   415,   440,   276,-32768,
   345,    24,-32768,   345,   444,   345,-32768,-32768,   453,-32768,
   281,   345,-32768,   547,   547,   280,   136,-32768,   262,   498,
-32768,   345,   291,-32768,-32768,   501,   293,   499,-32768,   188,
   208,-32768,   231,-32768,   505,-32768,   320,-32768,   366,   429,
    69,   508,   322,-32768,   236,   345,   327,   506,   512,-32768,
   511,-32768,   330,-32768,-32768,-32768,   275,   404,   467,   510,
-32768,-32768,   404,   514,   520,-32768,-32768,   980,   769,   531,
   529,-32768,-32768,   455,-32768,   601,   605,-32768,   608,   280,
   660,   339,   660,-32768,   543,   455,   660,   545,   660,   546,
    59,   548,   823,-32768,   823,-32768,   785,   233,-32768,   769,
   332,-32768,   547,-32768,   785,-32768,   552,   660,-32768,   542,
-32768,-32768,   345,-32768,   177,-32768,-32768,   877,   553,-32768,
-32768,-32768,   303,-32768,    92,-32768,    92,-32768,-32768,   345,
   555,   785,   785,-32768,-32768,-32768,   133,   345,   342,-32768,
   345,  1051,   785,-32768,   660,-32768,   345,   549,-32768,-32768,
   345,-32768,   556,   660,   292,-32768,-32768,-32768,-32768,-32768,
   563,   136,   136,   547,   547,   547,   547,   547,-32768,   564,
-32768,    94,-32768,-32768,-32768,   660,-32768,   133,-32768,   133,
-32768,   133,-32768,-32768,   345,-32768,-32768,   888,-32768,-32768,
    69,-32768,   345,    69,   347,-32768,-32768,-32768,-32768,-32768,
   785,   297,   404,-32768,-32768,   570,   589,-32768,   587,-32768,
   980,   608,   588,   233,-32768,   769,   590,   785,   785,   785,
   785,   980,   584,   585,   307,-32768,-32768,   455,   591,-32768,
   769,   395,-32768,   403,-32768,   412,-32768,-32768,-32768,   427,
   455,-32768,   915,   280,   592,   593,   597,-32768,   428,   455,
   431,-32768,-32768,   348,   602,   598,   455,   127,-32768,   438,
   475,   446,-32768,-32768,-32768,   454,-32768,   280,   604,   189,
-32768,-32768,   295,-32768,-32768,   241,   259,-32768,   611,   603,
-32768,-32768,   458,   610,   239,-32768,   612,-32768,   613,-32768,
-32768,-32768,-32768,-32768,-32768,  1051,-32768,-32768,-32768,   685,
-32768,-32768,   696,-32768,   993,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   263,   476,-32768,-32768,-32768,-32768,   477,-32768,
   609,   619,   345,   614,   769,-32768,   136,   136,-32768,-32768,
-32768,-32768,-32768,   769,   480,   618,   620,   622,-32768,   624,
   280,   626,-32768,-32768,-32768,-32768,   701,   621,   455,   926,
-32768,-32768,   481,-32768,-32768,-32768,   785,   640,   280,   637,
   769,-32768,-32768,   601,   601,   605,-32768,   712,   500,   660,
   711,   380,   642,   644,   645,   648,   404,-32768,   731,-32768,
   659,   937,-32768,   475,-32768,   785,-32768,-32768,   785,-32768,
   662,   664,-32768,   877,   948,-32768,   657,   676,-32768,-32768,
-32768,   304,   304,   665,-32768,   677,-32768,-32768,   678,-32768,
-32768,   684,-32768,   686,   133,-32768,   345,   345,-32768,   332,
-32768,   345,  1014,-32768,-32768,   980,   698,-32768,-32768,   699,
   700,   345,   711,-32768,-32768,   785,   529,   529,-32768,   702,
   715,   717,-32768,-32768,   693,   489,-32768,-32768,   718,   980,
   720,   404,   722,   492,   404,   269,-32768,   980,   716,-32768,
   769,   382,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   724,-32768,   455,-32768,-32768,   683,-32768,-32768,-32768,   455,
-32768,-32768,-32768,-32768,-32768,   980,-32768,-32768,   295,   719,
  1040,-32768,   733,-32768,-32768,-32768,-32768,   495,   507,-32768,
-32768,-32768,-32768,-32768,-32768,   721,-32768,-32768,   455,   728,
   729,-32768,-32768,-32768,   801,-32768,   701,-32768,   732,-32768,
-32768,-32768,   735,   734,   737,   736,   980,   387,-32768,-32768,
   404,-32768,   751,   750,-32768,-32768,-32768,-32768,   756,-32768,
-32768,   743,   711,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   980,   757,-32768,-32768,-32768,   980,-32768,-32768,-32768,
   404,-32768,-32768,   754,   761,   980,-32768,-32768,   818,   847,
-32768
};

static const short yypgoto[] = {-32768,
-32768,   788,-32768,-32768,   846,-32768,-32768,   848,-32768,-32768,
-32768,-32768,   738,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   766,   -98,-32768,-32768,-32768,
  -166,-32768,   210,-32768,-32768,-32768,-32768,    11,-32768,   229,
-32768,-32768,-32768,   206,   -99,-32768,-32768,-32768,   663,  -157,
-32768,   669,  -167,-32768,-32768,-32768,   628,-32768,-32768,   482,
-32768,   -97,-32768,-32768,   -90,   -89,-32768,   450,   -78,   441,
-32768,-32768,-32768,-32768,   283,-32768,-32768,   120,  -103,-32768,
-32768,   315,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   468,
-32768,-32768,  -171,-32768,-32768,-32768,   515,-32768,   152,-32768,
   148,-32768,   374,  -178,-32768,-32768,-32768,-32768,    -3,-32768,
-32768,-32768,-32768,-32768,  -405,-32768,-32768,   851,    26,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   145,
-32768,-32768,-32768,-32768,   821,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -200,
   277,-32768,-32768,  -274,  -419,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -133,   184,
-32768,-32768,   353,  -494,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   279,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -114,-32768,
   123,   456,   452,  -263,   -51,  -186,   100,    29,   571,-32768,
  -464,  -532,  -612,  -542,   282,  -177,-32768,  -319,   289,-32768,
-32768,  -132,  -445,    32,    43,    40,    -9,-32768,  -253,    -6,
  -199
};


#define	YYLAST		1505


static const short yytable[] = {   179,
   246,   183,   279,   280,   194,   315,   361,   318,   205,   320,
   281,   282,   206,   202,   304,   490,   417,   351,   352,   326,
   220,   277,   223,   346,   443,   356,   592,   611,   204,   583,
   342,   151,   230,   170,   442,   151,   332,   240,   638,   153,
   658,   334,   152,   153,   255,   240,   152,   681,   151,   212,
   328,   181,   182,   181,   182,   484,   153,   392,   393,   152,
     3,     2,     3,   207,   157,   158,   159,   160,   161,   162,
   163,   164,   260,   261,   416,   756,   170,    37,   263,   298,
   265,   181,   182,   181,   182,   170,   269,   154,   437,   275,
   275,   151,   195,   439,     2,     3,   181,   182,   208,   153,
   180,   185,   152,   185,   287,   210,   266,   288,   379,   272,
   272,   293,   462,   181,   182,   231,   464,   218,   466,   181,
   182,   181,   182,   731,     2,     3,   209,   157,   158,   159,
   160,   161,   162,   163,   164,   181,   182,   492,   357,   276,
   339,   358,   298,   292,   196,   468,   165,   749,   469,   151,
   213,   244,     2,     3,   295,   245,   418,   153,   658,   170,
   152,   366,   297,   344,   367,   296,   706,   717,   718,   792,
   186,   592,   186,   764,   544,   346,   340,   219,   684,   196,
   194,   194,   225,   501,   444,   252,   602,   342,   598,   181,
   182,   181,   454,   202,   226,   185,   458,   425,   458,   185,
   271,   264,   458,   251,   458,   565,   471,   557,   558,   313,
   252,   314,   480,   227,   244,   304,   487,  -447,   245,   394,
   480,   378,   508,   395,   383,   396,   387,   397,   151,     2,
     3,   241,   391,   582,   354,   353,   153,   196,   355,   152,
   257,   566,   400,   567,   794,   568,   231,   506,   507,   641,
   550,   448,   449,   798,   638,   236,   638,   341,   543,   448,
   449,   494,    34,   329,   186,   359,   275,   330,   186,   360,
   321,   474,   407,   474,   286,   408,   196,   448,   449,   488,
   667,   448,   449,   398,   333,   293,   272,   448,   449,   668,
   181,   182,   409,   237,   270,   410,   498,   181,   182,   238,
   628,   158,   159,   160,   161,   629,   630,   631,   294,   157,
   158,   159,   160,   161,   312,   411,   579,   573,   412,   483,
   575,   351,   352,   348,   692,   424,   323,   642,   370,   325,
   728,   304,   371,   194,     2,     3,   285,   157,   158,   159,
   160,   161,   162,   163,   164,   643,   304,   181,   182,   659,
   205,   202,   298,   202,   214,   755,   479,   512,   517,   434,
   376,   520,   435,   436,   377,   389,   571,   545,   215,   390,
   504,   383,   394,   216,   551,   401,   395,   404,   552,   402,
   553,   405,   649,   580,   651,   581,   151,   632,   151,   589,
   327,   633,   255,   599,   153,   600,   153,   152,   512,   152,
   512,   217,   512,   331,   414,   269,   422,   700,   415,   336,
   423,   426,   333,   275,   429,   423,   758,   347,   430,   165,
  -385,   474,   473,   460,   244,   266,   518,   461,   245,   290,
   519,   576,   617,   272,   416,   423,   446,   335,     2,     3,
   304,   157,   158,   159,   160,   161,   162,   163,   164,   304,
   338,     2,     3,   348,   157,   158,   159,   160,   161,   162,
   163,   164,   607,   364,   695,   641,   759,   694,   446,   298,
   446,   784,   686,   448,   449,   446,   304,     2,     3,   279,
   280,   603,   751,   600,   304,   754,   365,   281,   282,   604,
   627,   600,   368,   639,   703,   559,   560,   561,   605,   374,
   600,   480,     2,     3,   710,   157,   158,   159,   160,   161,
   162,   163,   164,   608,  -370,   609,  -370,   615,   215,   616,
   298,   372,   621,   165,   620,   166,   616,   375,   246,   737,
   297,   384,   622,   296,   600,   480,   317,   388,   314,   353,
   623,   244,   624,   387,   646,   245,   647,   726,   727,     2,
     3,   739,   157,   158,   159,   160,   161,   162,   163,   164,
   474,   785,   660,   661,   600,   662,   669,   683,   600,   581,
   594,   595,   498,   498,   682,   746,   304,   747,   753,   685,
   581,   770,   399,   616,   690,   403,   406,   299,   691,   413,
   427,   795,   244,   771,   438,   647,   245,   421,   488,   428,
   271,   440,     2,     3,   246,   157,   158,   159,   160,   161,
   162,   163,   164,   441,    10,   445,    12,   446,   450,    15,
   298,   451,   689,   452,    20,    21,    22,   463,   246,   465,
   467,   491,   472,   493,   165,   512,   589,   517,   517,   790,
   546,   500,   517,   505,   548,   708,    41,   556,    43,    10,
   278,    12,   736,   297,    15,   562,   296,   584,    51,    20,
    21,    22,   453,   454,   571,   157,   158,   159,   160,   161,
   162,   163,   164,   585,   593,   586,   591,  -452,  -453,   613,
   298,    41,   612,    43,   601,   614,   619,   319,   618,   314,
   654,   645,   244,    51,   625,   761,   245,   644,   648,   650,
   652,   655,   663,   664,   670,   589,   671,   666,   672,   639,
   673,   768,   674,     2,     3,   675,   157,   158,   159,   160,
   161,   162,   163,   164,   687,   688,   696,-32768,   697,   698,
   589,   298,   699,     2,     3,   571,   157,   158,   159,   160,
   161,   162,   163,   164,   571,   704,   711,   165,   712,   314,
   716,   298,   244,   719,     2,     3,   245,   157,   158,   159,
   160,   161,   162,   163,   164,  -460,   721,  -224,   722,   762,
   724,     2,     3,   791,   157,   158,   159,   160,   161,   162,
   163,   164,   732,   733,   734,   745,   742,     2,     3,   298,
   157,   158,   159,   160,   161,   162,   163,   164,   165,   743,
   314,   744,   748,   244,   750,   298,   752,   245,   760,   757,
   766,   769,   774,   775,   773,   776,   778,   800,   165,   779,
   702,   781,   780,   244,   782,     2,     3,   245,   157,   158,
   159,   160,   161,   162,   163,   164,   243,   786,   787,   165,
   788,   789,   796,   793,   244,   797,   801,   259,   245,   155,
   262,   156,   713,   345,   725,   291,   299,   729,   343,   380,
   678,   244,   547,   574,   569,   245,   777,   665,   767,   563,
   765,   502,   165,   626,   211,   256,   693,   244,   653,     2,
     3,   245,   157,   158,   159,   160,   161,   162,   163,   164,
     2,     3,   707,   157,   158,   159,   160,   161,   162,   163,
   164,   783,   597,   489,   709,   596,   715,     0,     0,     0,
   165,     0,     0,   473,     0,   244,     0,     2,     3,   245,
   157,   158,   159,   160,   161,   162,   163,   164,     2,     3,
     0,   157,   158,   159,   160,   161,   162,   163,   164,     2,
     3,     0,   157,   158,   159,   160,   161,   162,   163,   164,
     2,     3,     0,   157,   158,   159,   160,   161,   162,   163,
   164,     0,     0,     0,   165,     0,   495,     0,     0,   244,
     0,     0,     0,   245,     0,   165,     0,   570,     0,     0,
   244,     0,     2,     3,   245,   157,   158,   159,   160,   161,
   162,   163,   164,     0,     0,     0,     0,     0,   521,     0,
     0,   610,   165,     0,   522,   523,   524,   244,     0,     0,
     0,   245,     0,   165,   680,   525,     0,     0,   244,   521,
     0,     0,   245,   705,   165,   522,   523,   524,     0,   244,
     0,     0,     0,   245,     0,   165,   525,   714,     0,     0,
   244,     0,   181,   182,   245,   157,   158,   159,   160,   161,
   629,   630,   631,     0,     0,     0,   521,     0,     0,     0,
     0,     0,   522,   523,   524,     0,     0,   165,     0,     0,
     0,     0,   244,   525,     0,     0,   245,     0,     0,   657,
   526,   527,     0,   528,   529,   530,     0,   531,   532,   533,
   534,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   730,   526,   527,     0,   528,   529,   530,     0,   531,   532,
   533,   534,     2,     3,     0,   157,   158,   159,   160,   161,
   162,   163,   164,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   632,     0,     0,     0,   633,     0,   526,   527,
     0,   528,   529,   530,     0,   531,   532,   533,   534,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    -2,     1,     0,     2,
     3,     4,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   311,     0,   166,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,     0,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,     0,    45,    46,    47,     0,    48,    49,    50,    51,
    52,    53,    54,    55,    56,     0,     0,    57,     0,    58,
     0,    59,    -1,     1,     0,     2,     3,     4,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,     0,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,     0,    45,    46,
    47,     0,    48,    49,    50,    51,    52,    53,    54,    55,
    56,     0,     0,    57,     0,    58,     1,    59,     2,     3,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,     0,    33,    34,
    35,    36,    37,    38,     0,    40,    41,    42,    43,    44,
     0,    45,    46,    47,     0,    48,    49,    50,    51,    52,
    53,    54,    55,    56,     2,     3,    57,     0,    58,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     5,     6,     7,     0,     0,
     0,    11,     0,    13,     0,     0,    16,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   289,     0,    28,     0,
     0,     0,     0,     0,     0,     0,    35,    36,    37,     0,
     0,    40,     0,     0,     0,     0,     0,    45,     0,    47,
     0,    48,     0,    50,     0,    52,    53,     0,    55,     0,
   290,     0,    57,     0,    58
};

static const short yycheck[] = {     6,
    52,    11,   101,   101,    14,   139,   206,   141,    18,   143,
   101,   101,    19,    17,   129,   335,   270,   196,   196,   152,
    30,   100,    32,   191,   299,   197,   446,   473,    18,   435,
   188,     0,    42,     5,   298,     4,   169,    47,   503,     0,
   535,   174,     0,     4,    54,    55,     4,   580,    17,    24,
   165,     3,     4,     3,     4,   330,    17,   244,   245,    17,
     4,     3,     4,    34,     6,     7,     8,     9,    10,    11,
    12,    13,    82,    83,     6,   688,    48,    57,    88,    21,
    90,     3,     4,     3,     4,    57,    96,    85,   288,    99,
   100,    60,    85,   293,     3,     4,     3,     4,    69,    60,
    36,    23,    60,    23,   114,    85,    96,   114,    85,    99,
   100,   118,   313,     3,     4,    92,   317,    85,   319,     3,
     4,     3,     4,   656,     3,     4,    88,     6,     7,     8,
     9,    10,    11,    12,    13,     3,     4,   338,    89,    89,
    92,    92,    21,   118,    88,    87,    88,   680,    90,   118,
    88,    93,     3,     4,   123,    97,    88,   118,   653,   131,
   118,    85,   123,    85,    88,   123,   612,   632,   633,   782,
    92,   591,    92,   716,   375,   343,   186,    85,   584,    88,
   190,   191,    80,   355,   299,    92,   461,   345,   452,     3,
     4,     3,     4,   197,    88,    23,   311,   276,   313,    23,
    90,    85,   317,    85,   319,   406,   321,   394,   395,    88,
    92,    90,   327,    12,    93,   330,   331,    91,    97,    93,
   335,   231,    90,    97,   234,    90,   236,    92,   197,     3,
     4,    48,   242,   433,    85,   196,   197,    88,    89,   197,
    57,   408,   252,   410,   787,   412,    92,   362,   363,   503,
   384,    19,    20,   796,   719,    88,   721,    85,   373,    19,
    20,    85,    54,    85,    92,    85,   276,    89,    92,    89,
    88,   323,    85,   325,    88,    88,    88,    19,    20,   331,
   555,    19,    20,    22,    23,   292,   276,    19,    20,   564,
     3,     4,    85,     6,    90,    88,   348,     3,     4,    12,
     6,     7,     8,     9,    10,    11,    12,    13,    82,     6,
     7,     8,     9,    10,   131,    85,   431,   421,    88,    87,
   424,   500,   500,    88,   599,    90,    88,    87,    85,    88,
   650,   446,    89,   343,     3,     4,    94,     6,     7,     8,
     9,    10,    11,    12,    13,    87,   461,     3,     4,    87,
   360,   355,    21,   357,    38,    87,   325,   367,   368,    85,
    85,   371,    88,    89,    89,    85,   418,   377,    52,    89,
   360,   381,    93,    57,   384,    85,    97,    85,    87,    89,
    89,    89,   515,    87,   517,    89,   355,    93,   357,   441,
    88,    97,   402,    87,   355,    89,   357,   355,   408,   357,
   410,    85,   412,    88,    85,   415,    85,   607,    89,     6,
    89,    85,    23,   423,    85,    89,   691,    89,    89,    88,
    88,   473,    91,    85,    93,   415,    85,    89,    97,    79,
    89,    85,    85,   423,     6,    89,    89,    88,     3,     4,
   555,     6,     7,     8,     9,    10,    11,    12,    13,   564,
    88,     3,     4,    88,     6,     7,     8,     9,    10,    11,
    12,    13,   469,    85,    85,   719,    85,   601,    89,    21,
    89,    85,   587,    19,    20,    89,   591,     3,     4,   578,
   578,    87,   682,    89,   599,   685,    85,   578,   578,    87,
   500,    89,    88,   503,   609,   396,   397,   398,    87,    85,
    89,   616,     3,     4,   619,     6,     7,     8,     9,    10,
    11,    12,    13,    87,    87,    89,    89,    87,    52,    89,
    21,    88,   491,    88,    87,    90,    89,    88,   580,   663,
   491,    88,    87,   491,    89,   650,    88,    85,    90,   500,
    87,    93,    89,   553,    87,    97,    89,   647,   648,     3,
     4,   666,     6,     7,     8,     9,    10,    11,    12,    13,
   612,   761,    87,    87,    89,    89,    87,    87,    89,    89,
   448,   449,   624,   625,   581,    87,   691,    89,    87,   586,
    89,    87,    85,    89,    85,    85,    88,    88,    89,    85,
    85,   791,    93,    87,    85,    89,    97,    90,   650,    88,
    90,    88,     3,     4,   656,     6,     7,     8,     9,    10,
    11,    12,    13,    94,    29,    85,    31,    89,    18,    34,
    21,    17,   591,    16,    39,    40,    41,    85,   680,    85,
    85,    80,    85,    92,    88,   645,   688,   647,   648,   773,
    92,    89,   652,    89,    89,   614,    61,    85,    63,    29,
    65,    31,   662,   614,    34,    92,   614,    88,    73,    39,
    40,    41,     3,     4,   716,     6,     7,     8,     9,    10,
    11,    12,    13,    85,    85,    89,    89,    94,    94,    87,
    21,    61,    91,    63,    94,    89,    89,    88,    87,    90,
     6,    89,    93,    73,    91,   702,    97,    87,    89,    88,
    88,     6,    94,    85,    87,   757,    87,    94,    87,   719,
    87,   721,    87,     3,     4,    15,     6,     7,     8,     9,
    10,    11,    12,    13,    85,    89,    85,    16,    85,    85,
   782,    21,    85,     3,     4,   787,     6,     7,     8,     9,
    10,    11,    12,    13,   796,    87,    85,    88,    85,    90,
    94,    21,    93,    89,     3,     4,    97,     6,     7,     8,
     9,    10,    11,    12,    13,    90,    90,    90,    85,    87,
    85,     3,     4,   780,     6,     7,     8,     9,    10,    11,
    12,    13,    85,    85,    85,    93,    85,     3,     4,    21,
     6,     7,     8,     9,    10,    11,    12,    13,    88,    85,
    90,    85,    85,    93,    85,    21,    85,    97,    85,    94,
    92,    79,    85,    85,    94,    15,    85,     0,    88,    85,
    90,    85,    89,    93,    89,     3,     4,    97,     6,     7,
     8,     9,    10,    11,    12,    13,    85,    87,    89,    88,
    85,    99,    89,    87,    93,    85,     0,    60,    97,     4,
    85,     4,   624,   191,   645,   118,    88,   652,   190,   232,
   578,    93,   381,   423,   415,    97,   747,   553,   721,   402,
   719,   357,    88,   500,    24,    55,   600,    93,   526,     3,
     4,    97,     6,     7,     8,     9,    10,    11,    12,    13,
     3,     4,   614,     6,     7,     8,     9,    10,    11,    12,
    13,   757,   451,   333,   616,   450,   625,    -1,    -1,    -1,
    88,    -1,    -1,    91,    -1,    93,    -1,     3,     4,    97,
     6,     7,     8,     9,    10,    11,    12,    13,     3,     4,
    -1,     6,     7,     8,     9,    10,    11,    12,    13,     3,
     4,    -1,     6,     7,     8,     9,    10,    11,    12,    13,
     3,     4,    -1,     6,     7,     8,     9,    10,    11,    12,
    13,    -1,    -1,    -1,    88,    -1,    90,    -1,    -1,    93,
    -1,    -1,    -1,    97,    -1,    88,    -1,    90,    -1,    -1,
    93,    -1,     3,     4,    97,     6,     7,     8,     9,    10,
    11,    12,    13,    -1,    -1,    -1,    -1,    -1,     6,    -1,
    -1,    87,    88,    -1,    12,    13,    14,    93,    -1,    -1,
    -1,    97,    -1,    88,    89,    23,    -1,    -1,    93,     6,
    -1,    -1,    97,    87,    88,    12,    13,    14,    -1,    93,
    -1,    -1,    -1,    97,    -1,    88,    23,    90,    -1,    -1,
    93,    -1,     3,     4,    97,     6,     7,     8,     9,    10,
    11,    12,    13,    -1,    -1,    -1,     6,    -1,    -1,    -1,
    -1,    -1,    12,    13,    14,    -1,    -1,    88,    -1,    -1,
    -1,    -1,    93,    23,    -1,    -1,    97,    -1,    -1,    87,
    88,    89,    -1,    91,    92,    93,    -1,    95,    96,    97,
    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    91,    92,    93,    -1,    95,    96,
    97,    98,     3,     4,    -1,     6,     7,     8,     9,    10,
    11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    93,    -1,    -1,    -1,    97,    -1,    88,    89,
    -1,    91,    92,    93,    -1,    95,    96,    97,    98,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,     3,
     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    90,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    -1,    53,
    54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
    64,    -1,    66,    67,    68,    -1,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    -1,    -1,    81,    -1,    83,
    -1,    85,     0,     1,    -1,     3,     4,     5,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    62,    63,    64,    -1,    66,    67,
    68,    -1,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    -1,    -1,    81,    -1,    83,     1,    85,     3,     4,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    -1,    53,    54,
    55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
    -1,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
    75,    76,    77,    78,     3,     4,    81,    -1,    83,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
    -1,    30,    -1,    32,    -1,    -1,    35,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    47,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,    -1,
    -1,    60,    -1,    -1,    -1,    -1,    -1,    66,    -1,    68,
    -1,    70,    -1,    72,    -1,    74,    75,    -1,    77,    -1,
    79,    -1,    81,    -1,    83
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/gnu/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else /* Not sparc */
#ifdef MSDOS
#include <malloc.h>
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif


#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */



#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 160 "/usr/local/gnu/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;
/*  number of tokens to shift before error messages enabled */
  int yychar1;
/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;
/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/

  int yylen;


  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif


      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }


 yybackup:



  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;


  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      yychar = YYLEX;
    }


  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;



  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */



  switch (yyn) {

case 5:
#line 244 "fortran.y"
{
			  if(current_module_hash == -1) {
			    implied_id_token(&(yyvsp[0]),unnamed_prog);
			    def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[0]),(Token*)NULL);
			    current_module_hash =
			      def_curr_module(&(yyvsp[0]));
			    current_module_type = type_PROGRAM;
			  }

			  if(curr_stmt_class == tok_END) {
			    if(prev_stmt_class != tok_RETURN)
			      do_RETURN(current_module_hash,&(yyvsp[0]));
			    END_processing(&(yyval));
			    goto_flag = prev_goto = FALSE;
			  }
			  prev_stmt_class = curr_stmt_class;
			  integer_context = FALSE;
			  true_prev_stmt_line_num = yyval.line_num;
			;
    break;}
case 10:
#line 280 "fortran.y"
{
#ifdef CHECK_LABELS
			  def_label(&(yyvsp[-1]));
#endif
			  if(executable_stmt)
			    prev_goto = goto_flag;
			;
    break;}
case 11:
#line 288 "fortran.y"
{
			  if(executable_stmt) {
			    if(prev_goto)
				syntax_error(yyvsp[0].line_num, NO_COL_NUM,
					"No path to this statement");
			    prev_goto = goto_flag;
			  }
			;
    break;}
case 12:
#line 299 "fortran.y"
{
			    exec_stmt_count = 0;
			    executable_stmt = FALSE;
			;
    break;}
case 13:
#line 304 "fortran.y"
{
			    executable_stmt = FALSE;
			;
    break;}
case 14:
#line 308 "fortran.y"
{	/* handle statement functions correctly */
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[0].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN) {
			    stmt_sequence_no = SEQ_STMT_FUN;
			    executable_stmt = FALSE;
			  }
			  else {
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
			    executable_stmt = TRUE;
			  }
			;
    break;}
case 15:
#line 321 "fortran.y"
{
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
			    executable_stmt = TRUE;
			;
    break;}
case 16:
#line 327 "fortran.y"
{
			    executable_stmt = TRUE;
			    if(stmt_sequence_no == 0)
			      stmt_sequence_no = SEQ_HEADER;
			    complex_const_allowed = FALSE; /* turn off flags */
			    inside_format=FALSE;
			    integer_context = FALSE;
			    in_assignment_stmt = FALSE;
			    yyval.line_num = prev_stmt_line_num; /* best guess */
			    yyerrok; /* (error message already given) */
			;
    break;}
case 17:
#line 341 "fortran.y"
{
			    current_module_type = type_PROGRAM;
			;
    break;}
case 18:
#line 345 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			;
    break;}
case 19:
#line 349 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			;
    break;}
case 20:
#line 353 "fortran.y"
{
			    current_module_type = type_BLOCK_DATA;
			;
    break;}
case 24:
#line 366 "fortran.y"
{
#ifdef ALLOW_INCLUDE
			  if(f77_standard) {
			      nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			  }
			   open_include_file(yyvsp[-1].value.string);
#else
			  syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				"statement not permitted");
#endif
			 ;
    break;}
case 25:
#line 385 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				stmt_sequence_no = SEQ_IMPLICIT;
			     }
			;
    break;}
case 26:
#line 391 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				   stmt_sequence_no = SEQ_IMPLICIT;
			     }
			     else if(stmt_sequence_no > SEQ_SPECIF) {
			       check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			     }
			;
    break;}
case 27:
#line 400 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_IMPLICIT);
			;
    break;}
case 28:
#line 404 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_STMT_FUN) {
				stmt_sequence_no = SEQ_STMT_FUN;
			      }
			;
    break;}
case 29:
#line 410 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			;
    break;}
case 30:
#line 416 "fortran.y"
{
			     goto_flag = prev_goto = FALSE;
			;
    break;}
case 40:
#line 436 "fortran.y"
{
			    goto_flag=TRUE;
			;
    break;}
case 41:
#line 440 "fortran.y"
{
			    goto_flag=FALSE;
			;
    break;}
case 64:
#line 473 "fortran.y"
{
			    goto_flag=FALSE;
			;
    break;}
case 65:
#line 477 "fortran.y"
{
			    prev_goto = goto_flag =FALSE;
			;
    break;}
case 68:
#line 486 "fortran.y"
{	/* Flag DO w/o label or DO WHILE forms here */
			  if(is_true(NONSTD_USAGE_FLAG,yyvsp[0].subclass))
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
#else
			    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				    "Nonstandard syntax");
#endif
			;
    break;}
case 69:
#line 498 "fortran.y"
{
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
#else
			    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				    "Nonstandard syntax");
#endif
			;
    break;}
case 73:
#line 515 "fortran.y"
{check_seq_header(&(yyvsp[0]));;
    break;}
case 74:
#line 517 "fortran.y"
{
			     def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			     current_module_hash =
			       def_curr_module(&(yyvsp[-1]));
			;
    break;}
case 75:
#line 530 "fortran.y"
{
			  do_ENTRY(&(yyvsp[-1]),(Token*)NULL
				   ,current_module_hash);
			;
    break;}
case 76:
#line 535 "fortran.y"
{
			  do_ENTRY(&(yyvsp[-4]),&(yyvsp[-2])
				   ,current_module_hash);
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_exprlist("entry stmt",&(yyvsp[-2]));
#endif
			;
    break;}
case 78:
#line 551 "fortran.y"
{
			     if(f77_standard) {
				nonstandard(yyvsp[-1].line_num,
			     (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))));
				msg_tail(": parentheses required");
			     }
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-1]),(Token*)NULL);
			 current_module_hash=
			   def_curr_module(&(yyvsp[-1]));
			;
    break;}
case 79:
#line 565 "fortran.y"
{
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-4]),&(yyvsp[-2]));
			 current_module_hash=
			   def_curr_module(&(yyvsp[-4]));
#ifdef DEBUG_PARSER
			 if(debug_parser)
			   print_exprlist("function stmt",&(yyvsp[-2]));
#endif
			;
    break;}
case 80:
#line 577 "fortran.y"
{
			     if(f77_standard) {
				nonstandard(yyvsp[-1].line_num,
			      (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))));
				msg_tail(": parentheses required");
			     }
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			 current_module_hash=
			   def_curr_module(&(yyvsp[-1]));
			;
    break;}
case 81:
#line 590 "fortran.y"
{
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-4]),&(yyvsp[-2]));
			 current_module_hash=
			   def_curr_module(&(yyvsp[-4]));
#ifdef DEBUG_PARSER
			 if(debug_parser)
			   print_exprlist("function stmt",&(yyvsp[-2]));
#endif
			;
    break;}
case 84:
#line 609 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			;
    break;}
case 89:
#line 628 "fortran.y"
{
			  def_function(
				 type_SUBROUTINE,size_DEFAULT,
				       &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyvsp[-1]));
			;
    break;}
case 90:
#line 637 "fortran.y"
{
			  def_function(
				 type_SUBROUTINE,size_DEFAULT,&(yyvsp[-4]),&(yyvsp[-2]));
			  current_module_hash=
			    def_curr_module(&(yyvsp[-4]));
#ifdef DEBUG_PARSER
			  if(debug_parser)
			    print_exprlist("subroutine stmt",&(yyvsp[-2]));
#endif
			;
    break;}
case 91:
#line 650 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			;
    break;}
case 92:
#line 656 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			;
    break;}
case 94:
#line 663 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 95:
#line 667 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			;
    break;}
case 96:
#line 673 "fortran.y"
{
			     def_arg_name(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			;
    break;}
case 97:
#line 678 "fortran.y"
{
			     yyval.class = type_byte(class_LABEL,type_LABEL);
			     yyval.subclass = 0;
			;
    break;}
case 98:
#line 688 "fortran.y"
{
			  ++block_data_number;
			  sprintf(unnamed_block_data+4,"%02d"
				  ,block_data_number%100);
			  implied_id_token(&(yyval),unnamed_block_data);

			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyval),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyval));
			;
    break;}
case 99:
#line 702 "fortran.y"
{
			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyvsp[-1]));
			;
    break;}
case 100:
#line 712 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			;
    break;}
case 101:
#line 716 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			;
    break;}
case 105:
#line 731 "fortran.y"
{
			     def_array_dim(&(yyvsp[-3]),&(yyvsp[-1]));
			;
    break;}
case 106:
#line 738 "fortran.y"
{
			     yyval.class = 1;
			     yyval.subclass = yyvsp[0].subclass;
			;
    break;}
case 107:
#line 743 "fortran.y"
{
			     yyval.class = yyvsp[-2].class + 1; /* one more dimension */
			     yyval.subclass = yyvsp[-2].subclass * yyvsp[0].subclass;
			;
    break;}
case 108:
#line 750 "fortran.y"
{
			      if( datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.subclass = yyvsp[0].value.integer;
			      else
				yyval.subclass = 0;
			;
    break;}
case 109:
#line 758 "fortran.y"
{	/* avoid getting 0 - 0 + 1 = 1 if bounds nonconstant */
			      if( datatype_of(yyvsp[-2].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[-2].subclass)
				 && datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.subclass = yyvsp[0].value.integer - yyvsp[-2].value.integer + 1;
			      else
				yyval.subclass = 0;
			;
    break;}
case 110:
#line 768 "fortran.y"
{
			     yyval.subclass = 0;
			;
    break;}
case 111:
#line 772 "fortran.y"
{
			     yyval.subclass = 0;
			;
    break;}
case 112:
#line 778 "fortran.y"
{equivalence_flag = TRUE;;
    break;}
case 113:
#line 779 "fortran.y"
{equivalence_flag = FALSE;;
    break;}
case 116:
#line 787 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			;
    break;}
case 117:
#line 791 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			;
    break;}
case 118:
#line 798 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			;
    break;}
case 119:
#line 802 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			;
    break;}
case 120:
#line 806 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			;
    break;}
case 124:
#line 821 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval), &(yyvsp[-1]));
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				   syntax_error(
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("blank common",&(yyvsp[-1]));
#endif

			;
    break;}
case 125:
#line 835 "fortran.y"
{
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error(
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");

			;
    break;}
case 126:
#line 843 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval),&(yyvsp[-2]));
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error(
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("blank common",&(yyvsp[-2]));
#endif
			;
    break;}
case 127:
#line 861 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			;
    break;}
case 128:
#line 865 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			;
    break;}
case 129:
#line 873 "fortran.y"
{
			     def_com_block(&(yyvsp[-1]),&(yyvsp[0]));
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("labeled common",&(yyvsp[0]));
#endif
			;
    break;}
case 130:
#line 886 "fortran.y"
{
			     yyval = yyvsp[-1];
			;
    break;}
case 131:
#line 891 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			;
    break;}
case 132:
#line 895 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			;
    break;}
case 133:
#line 901 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 134:
#line 906 "fortran.y"
{
			    if(!is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num-1,
					"missing comma");
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			;
    break;}
case 135:
#line 919 "fortran.y"
{			   /* no comma */
			     yyval.subclass = yyvsp[0].subclass;
			     make_false(COMMA_FLAG,yyval.subclass);
			;
    break;}
case 136:
#line 924 "fortran.y"
{			   /* has comma */
			     yyval.subclass = yyvsp[-1].subclass;
			     make_true(COMMA_FLAG,yyval.subclass);
			   ;
    break;}
case 137:
#line 931 "fortran.y"
{
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			;
    break;}
case 138:
#line 936 "fortran.y"
{
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			;
    break;}
case 139:
#line 949 "fortran.y"
{
			    if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error(yyvsp[-1].line_num,
				 (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))),
					"trailing comma");
			    if(f77_standard) {
				nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			    }
			;
    break;}
case 141:
#line 962 "fortran.y"
{
			    yyval = yyvsp[0];
			;
    break;}
case 142:
#line 968 "fortran.y"
{
			     def_namelist(&(yyvsp[-1]),&(yyvsp[0]));
			     yyval = yyvsp[0];
			;
    break;}
case 143:
#line 975 "fortran.y"
{
			    yyval = yyvsp[-1];
			;
    break;}
case 144:
#line 981 "fortran.y"
{
			     yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 145:
#line 985 "fortran.y"
{
			    if(!is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num-1,
					"missing comma");
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			;
    break;}
case 146:
#line 998 "fortran.y"
{			   /* no comma */
			     def_namelist_item(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     make_false(COMMA_FLAG,yyval.subclass);
			;
    break;}
case 147:
#line 1004 "fortran.y"
{			   /* has comma */
			     def_namelist_item(&(yyvsp[-1]));
			     primary_id_expr(&(yyvsp[-1]),&(yyval));
			     make_true(COMMA_FLAG,yyval.subclass);
			;
    break;}
case 152:
#line 1019 "fortran.y"
{
			  current_typesize = size_DEFAULT;
			;
    break;}
case 153:
#line 1024 "fortran.y"
{
			    current_typesize = yyvsp[0].value.integer;
#if 0 /* defunct feature */
			    if(local_wordsize > 0) {
			      /*  recognize REAL*2w as DOUBLE PRECISION */
			      if(current_datatype == type_REAL
				 && yyvsp[0].value.integer == type_size[type_DP])
				current_datatype = type_DP;
			      /*  recognize COMPLEX*4w as DOUBLE COMPLEX */
			      if(current_datatype == type_COMPLEX
				 && yyvsp[0].value.integer==type_size[type_DCOMPLEX])
				current_datatype = type_DCOMPLEX;
			    }
#endif
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			;
    break;}
case 155:
#line 1047 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     integer_context = TRUE;
			;
    break;}
case 156:
#line 1052 "fortran.y"
{
			     current_datatype = type_REAL;
			     integer_context = TRUE;
			;
    break;}
case 157:
#line 1057 "fortran.y"
{
			     current_datatype = type_COMPLEX;
			     integer_context = TRUE;
			;
    break;}
case 158:
#line 1062 "fortran.y"
{
			     current_datatype = type_LOGICAL;
			     integer_context = TRUE;
			;
    break;}
case 159:
#line 1069 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			;
    break;}
case 160:
#line 1074 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			;
    break;}
case 161:
#line 1079 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			;
    break;}
case 162:
#line 1087 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			;
    break;}
case 163:
#line 1095 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     current_typesize = 1;
			     if(f77_standard)
			       nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			;
    break;}
case 164:
#line 1104 "fortran.y"
{
			     current_datatype = type_STRING;
			     current_typesize = 1;
			     integer_context = TRUE;
			;
    break;}
case 165:
#line 1112 "fortran.y"
{
			     current_typesize = yyvsp[0].value.integer;
			;
    break;}
case 168:
#line 1122 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			;
    break;}
case 169:
#line 1127 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			;
    break;}
case 172:
#line 1138 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			;
    break;}
case 173:
#line 1143 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
			;
    break;}
case 174:
#line 1148 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			;
    break;}
case 175:
#line 1153 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
			;
    break;}
case 176:
#line 1161 "fortran.y"
{implicit_flag=TRUE;;
    break;}
case 177:
#line 1165 "fortran.y"
{
			    implicit_flag=FALSE;
			    if(implicit_none) {
				syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				     "conflicts with IMPLICIT NONE");
			    }
			    else {
				implicit_type_given = TRUE;
			    }
			;
    break;}
case 178:
#line 1177 "fortran.y"
{
			    implicit_flag=FALSE;
				if(implicit_type_given) {
				    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
					 "conflicts with IMPLICIT statement");
				}
				else {
				    if(f77_standard)
				      nonstandard(yyvsp[-1].line_num,yyvsp[-1].col_num);
				    implicit_none = TRUE;
				}
			;
    break;}
case 180:
#line 1192 "fortran.y"
{initial_flag = TRUE;;
    break;}
case 182:
#line 1198 "fortran.y"
{implicit_letter_flag = TRUE;;
    break;}
case 183:
#line 1199 "fortran.y"
{implicit_letter_flag = FALSE;;
    break;}
case 186:
#line 1207 "fortran.y"
{
			  int c1 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1))) {
			    nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			    msg_tail(": nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
					     c1,c1);
			;
    break;}
case 187:
#line 1219 "fortran.y"
{
			  int c1 = (int)yyvsp[-2].subclass,
			      c2 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1) || !isalpha(c2))) {
			    if(!isalpha(c1))
			      nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			    else
			      nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			    msg_tail("nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
					c1,c2);
			;
    break;}
case 188:
#line 1239 "fortran.y"
{yyval.value.integer = size_ADJUSTABLE;;
    break;}
case 189:
#line 1241 "fortran.y"
{yyval.value.integer = yyvsp[0].value.integer;;
    break;}
case 190:
#line 1243 "fortran.y"
{
			      if((yyval.value.integer = yyvsp[-1].value.integer) <= 0 ){
				warning(yyvsp[-1].line_num,yyvsp[-1].col_num,
					"invalid length specification");
				msg_tail(": substituting 1");
				yyval.value.integer = 1;
			      }
			    ;
    break;}
case 194:
#line 1261 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 195:
#line 1263 "fortran.y"
{
			     def_parameter(&(yyvsp[-3]),&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[-3]),&(yyvsp[-3]));
			     assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-1]),&(yyvsp[0]));
			     complex_const_allowed = FALSE;
			;
    break;}
case 197:
#line 1276 "fortran.y"
{
			     def_ext_name(&(yyvsp[0]));
			;
    break;}
case 198:
#line 1280 "fortran.y"
{
			     def_ext_name(&(yyvsp[0]));
			;
    break;}
case 200:
#line 1290 "fortran.y"
{
			     def_intrins_name(&(yyvsp[0]));
			;
    break;}
case 201:
#line 1294 "fortran.y"
{
			     def_intrins_name(&(yyvsp[0]));
			;
    break;}
case 202:
#line 1301 "fortran.y"
{
			  global_save = TRUE;
			;
    break;}
case 206:
#line 1312 "fortran.y"
{
			     save_variable(&(yyvsp[0]));
			;
    break;}
case 207:
#line 1316 "fortran.y"
{
/***			     def_com_block(&($2),(Token*)NULL);***/
			     save_com_block(&(yyvsp[-1]));
			;
    break;}
case 212:
#line 1332 "fortran.y"
{complex_const_allowed=TRUE;;
    break;}
case 213:
#line 1334 "fortran.y"
{complex_const_allowed=FALSE;;
    break;}
case 217:
#line 1343 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			;
    break;}
case 224:
#line 1359 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			;
    break;}
case 226:
#line 1366 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			;
    break;}
case 229:
#line 1377 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			;
    break;}
case 231:
#line 1385 "fortran.y"
{
			    use_implied_do_index(&(yyvsp[-3]));
			;
    break;}
case 234:
#line 1396 "fortran.y"
{complex_const_allowed = TRUE;
				    in_assignment_stmt = TRUE;;
    break;}
case 235:
#line 1398 "fortran.y"
{
			  assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-2]),
					&(yyvsp[0]));
			  complex_const_allowed = FALSE;
			  in_assignment_stmt = FALSE;
			;
    break;}
case 236:
#line 1405 "fortran.y"
{
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[-5].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN)
			     stmt_function_stmt(&(yyvsp[-5]));
			;
    break;}
case 241:
#line 1423 "fortran.y"
{
			    do_ASSIGN(&(yyvsp[-1]));
			;
    break;}
case 245:
#line 1440 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-1]));
			;
    break;}
case 246:
#line 1444 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-4]));
			;
    break;}
case 247:
#line 1448 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-5]));
			;
    break;}
case 248:
#line 1454 "fortran.y"
{
			    integer_context=TRUE;
			;
    break;}
case 249:
#line 1458 "fortran.y"
{
			    integer_context=TRUE;
			;
    break;}
case 252:
#line 1470 "fortran.y"
{
			  int t=datatype_of(yyvsp[-9].class);
			  if(t != type_INTEGER && t != type_REAL
			     && t != type_DP && t != type_ERROR ) {
			    syntax_error(yyvsp[-9].line_num,yyvsp[-9].col_num,
		  "integer, real, or double precision expression required");
			  }
			;
    break;}
case 253:
#line 1482 "fortran.y"
{
			  int t=datatype_of(yyvsp[-1].class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error(yyvsp[-1].line_num,yyvsp[-1].col_num,
					  "logical expression required");
			;
    break;}
case 254:
#line 1492 "fortran.y"
{
			  int t=datatype_of(yyvsp[-2].class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
					  "logical expression required");
			;
    break;}
case 255:
#line 1500 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 256:
#line 1501 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;	/* for is_keyword */
			    yyval = yyvsp[-1]; /* Inherit expr for type checking above */
			;
    break;}
case 258:
#line 1514 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 259:
#line 1515 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;
			;
    break;}
case 264:
#line 1545 "fortran.y"
{
			     use_lvalue(&(yyvsp[-3]));
			     use_variable(&(yyvsp[-3]));

			     if(datatype_of(yyvsp[-3].class) == type_INTEGER
				&& datatype_of(yyvsp[-1].class) != type_INTEGER)
			       warning(yyvsp[-2].line_num,yyvsp[-2].col_num,
				  "type mismatch between DO index and bounds");

			     else if(datatype_of(yyvsp[-3].class) != type_INTEGER)
			       if(datatype_of(yyvsp[-1].class) != type_INTEGER) {
				 if(port_check)
				   nonportable(yyvsp[-1].line_num,yyvsp[-1].col_num,
					       "non-integer DO loop bounds");
			       }
			       else {
				 if(trunc_check)
				   warning(yyvsp[-3].line_num,yyvsp[-3].col_num,
					   "DO index is not integer");
			       }
			;
    break;}
case 265:
#line 1568 "fortran.y"
{complex_const_allowed=TRUE;;
    break;}
case 266:
#line 1569 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			;
    break;}
case 267:
#line 1577 "fortran.y"
{complex_const_allowed=TRUE;;
    break;}
case 268:
#line 1578 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			;
    break;}
case 271:
#line 1590 "fortran.y"
{
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			    integer_context=FALSE;
			;
    break;}
case 272:
#line 1597 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-2]),&(yyvsp[0]),&(yyvsp[0]));
			;
    break;}
case 273:
#line 1601 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-4]),&(yyvsp[-2]),&(yyvsp[0]));
			;
    break;}
case 281:
#line 1625 "fortran.y"
{
			     use_variable(&(yyvsp[0]));
			;
    break;}
case 283:
#line 1633 "fortran.y"
{complex_const_allowed = FALSE;;
    break;}
case 285:
#line 1635 "fortran.y"
{complex_const_allowed = FALSE;;
    break;}
case 287:
#line 1638 "fortran.y"
{control_item_count = 0;;
    break;}
case 288:
#line 1640 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 294:
#line 1653 "fortran.y"
{control_item_count = 0;;
    break;}
case 295:
#line 1657 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			;
    break;}
case 296:
#line 1662 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-4].line_num,yyvsp[-4].col_num);
			;
    break;}
case 298:
#line 1671 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 299:
#line 1672 "fortran.y"
{complex_const_allowed = FALSE;;
    break;}
case 301:
#line 1676 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			;
    break;}
case 302:
#line 1681 "fortran.y"
{complex_const_allowed = TRUE;;
    break;}
case 303:
#line 1682 "fortran.y"
{complex_const_allowed = FALSE;;
    break;}
case 304:
#line 1683 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-6].line_num,yyvsp[-6].col_num);
			;
    break;}
case 305:
#line 1691 "fortran.y"
{
			    ++control_item_count;
			;
    break;}
case 306:
#line 1695 "fortran.y"
{
			    ++control_item_count;
			;
    break;}
case 307:
#line 1704 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			;
    break;}
case 308:
#line 1708 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
					/* WRITE(string,...) means store
					   output in the string */
				if(curr_stmt_class == tok_WRITE
				 && control_item_count == 0
				 && datatype_of(yyvsp[0].class) == type_STRING)
				    use_lvalue(&(yyvsp[0]));
					/* READ/WRITE(..,namelist) means
					   I/O with variables of namelist. */
				else if( control_item_count == 1
				    && datatype_of(yyvsp[0].class) == type_NAMELIST)
				    ref_namelist(&(yyvsp[0]),curr_stmt_class);

				use_variable(&(yyvsp[0]));
			    }
			;
    break;}
case 309:
#line 1734 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    ++control_item_count;
			;
    break;}
case 310:
#line 1742 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			    ++control_item_count;
			;
    break;}
case 311:
#line 1747 "fortran.y"
{
			    ++control_item_count;
			;
    break;}
case 312:
#line 1753 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			;
    break;}
case 313:
#line 1757 "fortran.y"
{
			    use_special_open_keywd(&(yyvsp[0]));
			;
    break;}
case 316:
#line 1768 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				if( curr_stmt_class == tok_READ ||
				    curr_stmt_class == tok_ACCEPT )
				    use_lvalue(&(yyvsp[0]));
				else
				    use_variable(&(yyvsp[0]));
			    }
			;
    break;}
case 318:
#line 1782 "fortran.y"
{
			     use_implied_do_index(&(yyvsp[-3]));
			;
    break;}
case 319:
#line 1788 "fortran.y"
{control_item_count = 0;;
    break;}
case 321:
#line 1793 "fortran.y"
{control_item_count = 0;;
    break;}
case 323:
#line 1798 "fortran.y"
{control_item_count = 0;;
    break;}
case 327:
#line 1806 "fortran.y"
{control_item_count = 0;;
    break;}
case 330:
#line 1813 "fortran.y"
{control_item_count = 0;;
    break;}
case 331:
#line 1814 "fortran.y"
{control_item_count = 0;;
    break;}
case 334:
#line 1821 "fortran.y"
{control_item_count = 0;;
    break;}
case 337:
#line 1835 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
			;
    break;}
case 339:
#line 1844 "fortran.y"
{inside_format=TRUE;;
    break;}
case 340:
#line 1845 "fortran.y"
{
			  inside_format=FALSE;
			;
    break;}
case 357:
#line 1876 "fortran.y"
{
			  if(f77_standard)
			     nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			;
    break;}
case 362:
#line 1891 "fortran.y"
{inside_format=FALSE;;
    break;}
case 363:
#line 1892 "fortran.y"
{inside_format=TRUE;;
    break;}
case 364:
#line 1893 "fortran.y"
{
			  if(f77_standard)
			     nonstandard(yyvsp[-4].line_num,yyvsp[-4].col_num);
			;
    break;}
case 365:
#line 1902 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[-3]),SEQ_STMT_FUN);

				def_stmt_function(&(yyvsp[-3]),&(yyvsp[-1]));
				primary_id_expr(&(yyvsp[-3]),&(yyval));
#ifdef DEBUG_PARSER
				if(debug_parser)
				  print_exprlist("stmt function",&(yyvsp[-1]));
#endif
			;
    break;}
case 366:
#line 1916 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			;
    break;}
case 368:
#line 1923 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 369:
#line 1928 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			;
    break;}
case 371:
#line 1938 "fortran.y"
{
			     call_subr(&(yyvsp[0]),(Token*)NULL);
			     complex_const_allowed = FALSE;
			;
    break;}
case 373:
#line 1944 "fortran.y"
{
			     call_subr(&(yyvsp[-2]),(Token*)NULL);
			     complex_const_allowed = FALSE;
			;
    break;}
case 375:
#line 1950 "fortran.y"
{
			     call_subr(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_exprlist("call stmt",&(yyvsp[-1]));
#endif
			     complex_const_allowed = FALSE;
			;
    break;}
case 377:
#line 1961 "fortran.y"
{
			     complex_const_allowed = TRUE;
			     yyval = yyvsp[0];
			;
    break;}
case 378:
#line 1967 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 379:
#line 1975 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 380:
#line 1979 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			;
    break;}
case 381:
#line 1987 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-4].next_token,&(yyvsp[0]));
			;
    break;}
case 382:
#line 1994 "fortran.y"
{
			     do_RETURN(current_module_hash,&(yyvsp[-1]));
			;
    break;}
case 383:
#line 1998 "fortran.y"
{
			     do_RETURN(current_module_hash,&(yyvsp[-2]));
			;
    break;}
case 384:
#line 2005 "fortran.y"
{
				if(!is_true(COMPLEX_FLAG,yyvsp[-3].subclass))
				  complex_const_allowed=FALSE;
				if(is_true(IN_ASSIGN,yyvsp[-3].subclass))
				  in_assignment_stmt = TRUE;

				if(yyvsp[-1].next_token == NULL)
				  call_func(&(yyvsp[-3]),(Token *)NULL);
				else
				  call_func(&(yyvsp[-3]),&(yyvsp[-1]));
				func_ref_expr(&(yyvsp[-3]),&(yyvsp[-1]),&(yyval));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("function",&(yyvsp[-1]));
#endif
			;
    break;}
case 385:
#line 2027 "fortran.y"
{
			  if(complex_const_allowed)/* save context */
			    make_true(COMPLEX_FLAG,yyval.subclass);
			  complex_const_allowed=TRUE;
			  if(in_assignment_stmt)
			    make_true(IN_ASSIGN,yyval.subclass);
			  in_assignment_stmt = FALSE;
			;
    break;}
case 386:
#line 2037 "fortran.y"
{
				yyval.class = 0;
				yyval.next_token = NULL;
			;
    break;}
case 388:
#line 2045 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 389:
#line 2049 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			;
    break;}
case 390:
#line 2057 "fortran.y"
{
			  int t=datatype_of(yyvsp[0].class);
			  if( t != type_ERROR){
			    if( ! is_const_type(t) ) {
			      syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
		      "arithmetic, char, or logical expression expected");
			    }
			    else {
			      if( !is_true(PARAMETER_EXPR,yyvsp[0].subclass) ) {
				syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
					   "constant expression expected");
			      }
			    /* Here we allow, with some warnings, expr
			       containing intrins func or **REAL in
			       PARAMETER defn. */
			      else if( !is_true(CONST_EXPR,yyvsp[0].subclass) ) {
				if(f77_standard) {
				  nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
				  msg_tail(
			 "intrinsic function or **REAL in PARAMETER defn");
				}
			      }
			    }
			  }
			;
    break;}
case 391:
#line 2086 "fortran.y"
{
#ifdef DEBUG_PARSER
			    if(debug_parser) {
				fprintf(list_fd,
					"\nexpr: class=0x%x subclass=0x%x",
					yyvsp[0].class,
					yyvsp[0].subclass);
			    }
#endif
			;
    break;}
case 393:
#line 2101 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 394:
#line 2106 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 396:
#line 2115 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 398:
#line 2124 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 400:
#line 2133 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			;
    break;}
case 402:
#line 2141 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 404:
#line 2151 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			;
    break;}
case 405:
#line 2155 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			;
    break;}
case 406:
#line 2159 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 407:
#line 2164 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 409:
#line 2173 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    if(div_check &&
			       !is_true(CONST_EXPR,yyvsp[0].subclass)){
				warning(yyvsp[-1].line_num,yyvsp[-1].col_num,
					"Possible division by zero");
			    }
			;
    break;}
case 410:
#line 2183 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 412:
#line 2192 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 414:
#line 2201 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			;
    break;}
case 419:
#line 2216 "fortran.y"
{
			    yyval.subclass = 0;
			    make_true(CONST_EXPR,yyval.subclass);
			    make_true(PARAMETER_EXPR,yyval.subclass);
			    make_true(LIT_CONST,yyval.subclass);
			    make_true(EVALUATED_EXPR,yyval.subclass);
			;
    break;}
case 420:
#line 2224 "fortran.y"
{
			    yyval = yyvsp[-1];
			    if(is_true(LVALUE_EXPR,yyvsp[-1].subclass)) {
				if(pretty_flag) {
				  ugly_code(yyvsp[-1].line_num,yyvsp[-1].col_num,
					  "Extraneous parentheses");
				}
				use_variable(&(yyvsp[-1]));
				make_false(LVALUE_EXPR,yyval.subclass);
				make_false(ARRAY_ID_EXPR,yyval.subclass);
				make_false(ID_EXPR,yyval.subclass);
			    }
			;
    break;}
case 421:
#line 2243 "fortran.y"
{
			    yyval.size = size_DEFAULT;
			;
    break;}
case 422:
#line 2248 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_STRING);
			;
    break;}
case 423:
#line 2253 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_HOLLERITH);
			    if(port_check && hollerith_check) {
				warning(yyvsp[0].line_num,yyvsp[0].col_num,
				"hollerith constant may not be portable");
			    }
			;
    break;}
case 424:
#line 2262 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_LOGICAL);
			    yyval.size = size_DEFAULT;
			;
    break;}
case 425:
#line 2269 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_INTEGER);
			;
    break;}
case 426:
#line 2273 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_REAL);
			;
    break;}
case 427:
#line 2277 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DP);
			;
    break;}
case 428:
#line 2281 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_COMPLEX);
			;
    break;}
case 429:
#line 2285 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DCOMPLEX);
			;
    break;}
case 430:
#line 2292 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    if(datatype_of(yyvsp[0].class) != type_INTEGER) {
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num,
					"expression must be integer type");
			    }
			;
    break;}
case 431:
#line 2306 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    {
				int t=datatype_of(yyvsp[0].class);
				    if(t != type_INTEGER && t != type_REAL
					&& t != type_DP ) {
					syntax_error(
					  yyvsp[0].line_num,yyvsp[0].col_num,
		"expression must be integer, real, or double precision type");
				        }
			    }
			;
    break;}
case 432:
#line 2326 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    if( ! is_true(CONST_EXPR,yyvsp[0].subclass) ) {
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num,
					"constant expression expected");
			    }
			    else {
			      if(datatype_of(yyvsp[0].class) != type_INTEGER){
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num,
					"integer expression expected");
			      }
			      else {
				yyval.value.integer = int_expr_value(&(yyvsp[0]));
			      }
			    }
			;
    break;}
case 433:
#line 2350 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }

			    if( datatype_of(yyvsp[0].class) != type_INTEGER ){
				syntax_error(
					yyvsp[0].line_num,yyvsp[0].col_num,
					"integer dimension expected");
				yyval.value.integer = 0;
			    }
			    else {
			      if( is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.value.integer =
				  int_expr_value(&(yyvsp[0]));
			      else		/* must be dummy */
				yyval.value.integer = 0;
			    }
			;
    break;}
case 434:
#line 2376 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array lvalue",&(yyvsp[-1]));
#endif
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			;
    break;}
case 435:
#line 2388 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array",&(yyvsp[-1]));
#endif
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			;
    break;}
case 436:
#line 2400 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			;
    break;}
case 437:
#line 2404 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			;
    break;}
case 438:
#line 2410 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
			    if(datatype_of(yyvsp[0].class) != type_INTEGER)
			      if(trunc_check)
				 warning(yyvsp[0].line_num,yyvsp[0].col_num,
					 "subscript is not integer");
			;
    break;}
case 439:
#line 2424 "fortran.y"
{
			    if(!is_true(COMPLEX_FLAG,yyvsp[-1].subclass))
				  complex_const_allowed=FALSE;
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			;
    break;}
case 440:
#line 2432 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			;
    break;}
case 441:
#line 2438 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			;
    break;}
case 442:
#line 2442 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			;
    break;}
case 443:
#line 2448 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=0; /* 0 means LEN */
			;
    break;}
case 444:
#line 2454 "fortran.y"
{
			    yyval.class=yyvsp[-2].value.integer;
			    yyval.subclass=0; /* 0 means LEN */
			;
    break;}
case 445:
#line 2459 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=yyvsp[-1].value.integer;
			;
    break;}
case 446:
#line 2464 "fortran.y"
{
			      yyval.class=yyvsp[-3].value.integer;
			      yyval.subclass=yyvsp[-1].value.integer;
			;
    break;}
case 447:
#line 2471 "fortran.y"
{
			  if(is_true(ID_EXPR,yyvsp[0].subclass)){
			    use_variable(&(yyvsp[0]));
			  }
				/* check validity and replace nonconst
				   value by size_UNKNOWN. */
			  if(is_true(CONST_EXPR,yyvsp[0].subclass)) {
			    if( (yyval.value.integer=int_expr_value(&(yyvsp[0]))) < 1) {
			      syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
					   "invalid substring index");
			    }
			  }
			  else  /* (no longer need ID hash index) */
			    yyval.value.integer=size_UNKNOWN;
			;
    break;}
case 450:
#line 2496 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			;
    break;}
case 451:
#line 2503 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			;
    break;}
case 460:
#line 2529 "fortran.y"
{
			  if(yyvsp[0].value.integer == 0) {
			    warning(yyvsp[0].line_num,yyvsp[0].col_num,
				    "nonzero integer expected");
			    msg_tail(": substituting 1");
			    yyval.value.integer = 1;
			  }
			;
    break;}
case 461:
#line 2544 "fortran.y"
{
			    integer_context=TRUE;
			;
    break;}
case 462:
#line 2551 "fortran.y"
{
				integer_context=FALSE;
				yyval.class = type_byte(class_LABEL,type_LABEL);
				yyval.subclass = 0;
			;
    break;}
}
#line 423 "/usr/local/gnu/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif


  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {

      if (yychar == YYEOF)
	YYABORT;


      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:
/* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];
/* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:
/* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif


yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;


  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 2560 "fortran.y"

void
init_parser()			/* Initialize various flags & counters */
{
	initial_flag = TRUE;	/* set flag for keyword test */
	implicit_flag=FALSE;	/* clear flags for IMPLICIT stmt */
	implicit_letter_flag = FALSE;
	implicit_type_given = FALSE;
	implicit_none = FALSE;
	global_save = FALSE;
	prev_token_class = EOS;
	complex_const_allowed = FALSE;
	stmt_sequence_no = 0;
	true_prev_stmt_line_num = 0;
}

		/* Propagate non-integer type if any of DO loop
		   bounds are non-integer. */
PRIVATE int
do_bounds_type(t1,t2,t3)
     Token *t1, *t2, *t3;
{
  int result_class;
       if(datatype_of(t1->class) != type_INTEGER) result_class = t1->class;
  else if(datatype_of(t2->class) != type_INTEGER) result_class = t2->class;
  else if(datatype_of(t3->class) != type_INTEGER) result_class = t3->class;
  else result_class = t1->class;
  return result_class;
}



PRIVATE void
print_exprlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s arglist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
	      while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
	    }
	}
}

PRIVATE void
print_comlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s varlist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
	      while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
		}
	  }
}

/* After having parsed prog_stmt, function_stmt, subroutine_stmt,
   block_data_stmt, the stmt_sequence_no is set to the value SEQ_HEADER.
*/

void
check_seq_header(t)
     Token *t;
{
	if(stmt_sequence_no >= SEQ_HEADER) {
	   syntax_error( (t == (Token *) NULL? line_num: t->line_num),
			NO_COL_NUM,
			"missing END statement inserted");
	   msg_tail( (t == (Token *) NULL? "at end of file":
		      "prior to statement") );

	   END_processing(t);
	}
	stmt_sequence_no = SEQ_HEADER;
}

void
check_stmt_sequence(t,seq_num)
     Token *t;
     int seq_num;
{
    if(stmt_sequence_no > seq_num) {
	 syntax_error(t->line_num, NO_COL_NUM,
		      "Statement out of order.");
    }
    else {
	stmt_sequence_no = seq_num;
    }
}

	/* After having parsed end_stmt, common block lists and
	   subprogram argument lists are copied over into global symbol
	   table, the local symbol table is printed out and then cleared,
	   and stmt_sequence_no is set to zero for start of next module.
	*/

PRIVATE void
END_processing(t)
	Token *t;
{
  if(current_module_hash != -1) {
	if(exec_stmt_count == 0 &&
	   current_module_type != type_BLOCK_DATA) {
	  warning(t == (Token *)NULL? line_num: t->line_num, NO_COL_NUM,
		  "Module contains no executable statements");
	}
	if(do_list && t != (Token *)NULL)
	    flush_line_out(t->line_num);
	check_loose_ends(current_module_hash);
	process_lists(current_module_hash);
	debug_symtabs();
	print_loc_symbols(current_module_hash);
	init_symtab();
  }
  exec_stmt_count = 0;
  stmt_sequence_no = 0;
  current_module_hash = -1;
  implicit_type_given = FALSE;
  implicit_none = FALSE;
  true_prev_stmt_line_num = 0;
  integer_context = FALSE;
  global_save = FALSE;
}

PRIVATE Token *
append_token(tlist,t)
     Token *tlist, *t;
{
	Token *tcopy;
	if((tcopy=new_token()) == (Token *)NULL){
	  oops_message(OOPS_FATAL,line_num,NO_COL_NUM,
#ifdef LARGE_MACHINE
"Out of token space\nRecompile me with larger TOKENSPACESZ value"
#else
"Out of token space\nRecompile me with LARGE_MACHINE option"
#endif
		       );
	}

	*tcopy = *t;		/* make permanent copy of token */
	tcopy->next_token = tlist; /* link it onto front of list */
	return tcopy;		/* return it as new tlist */
}
